package com.example.epos_2021.activities;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.location.Location;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.widget.Toolbar;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.lifecycle.ViewModelProvider;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.androidnetworking.AndroidNetworking;
import com.androidnetworking.error.ANError;
import com.androidnetworking.interfaces.ParsedRequestListener;
import com.daimajia.swipe.SwipeLayout;
import com.example.epos_2021.Links;
import com.example.epos_2021.MyApp;
import com.example.epos_2021.R;
import com.example.epos_2021.adapters.OrderButtonsAdapter;
import com.example.epos_2021.adapters.OrderItemsAdapter;
import com.example.epos_2021.adapters.OrderOptionMenuAdapter;
import com.example.epos_2021.base.BaseActivity;
import com.example.epos_2021.comman.CommonFunctions;
import com.example.epos_2021.comman.Validators;
import com.example.epos_2021.comman.printer.SunmiPrinter;
import com.example.epos_2021.comman.printer.WifiPrinter;
import com.example.epos_2021.comman.printer.ZoneRichPrinter;
import com.example.epos_2021.daos.relations.OrderItemWithAddonsIngredients;
import com.example.epos_2021.daos.relations.OrderWithItems;
import com.example.epos_2021.fragment.AddCommentFragment;
import com.example.epos_2021.fragment.AssignTableDialogFragment;
import com.example.epos_2021.fragment.CancelOrderDialogFragment;
import com.example.epos_2021.fragment.CartProductEditDialogFragment;
import com.example.epos_2021.fragment.ConfirmationDialogFragment;
import com.example.epos_2021.fragment.ConvertOrderTypeFragment;
import com.example.epos_2021.fragment.CustomerInfoDialogFragment;
import com.example.epos_2021.fragment.DiscountDialogFragment;
import com.example.epos_2021.fragment.MainCategoryFragment;
import com.example.epos_2021.fragment.MiscItemFragment;
import com.example.epos_2021.fragment.NewOrderDialogFragment;
import com.example.epos_2021.fragment.OrderItemViewDialogFragment;
import com.example.epos_2021.fragment.OrderTypeSelectionDialogFragment;
import com.example.epos_2021.fragment.PaymentViaVoucherFragment;
import com.example.epos_2021.fragment.PrintOptionsDialogFragment;
import com.example.epos_2021.fragment.ProductAreaFragment;
import com.example.epos_2021.fragment.SendOrderDialogFragment;
import com.example.epos_2021.interfaces.DialogDismissListener;
import com.example.epos_2021.models.ApiError;
import com.example.epos_2021.models.CallLogs;
import com.example.epos_2021.models.CalllogViewModel;
import com.example.epos_2021.models.CustomMenuItem;
import com.example.epos_2021.models.Customer;
import com.example.epos_2021.models.DeliveryCharge;
import com.example.epos_2021.models.Discount;
import com.example.epos_2021.models.Order;
import com.example.epos_2021.models.OrderButton;
import com.example.epos_2021.models.OrderItem;
import com.example.epos_2021.models.OrderItemAddon;
import com.example.epos_2021.models.OrderItemIngredient;
import com.example.epos_2021.models.OrderPayment;
import com.example.epos_2021.models.OrderSplit;
import com.example.epos_2021.models.PaymentMethod;
import com.example.epos_2021.models.Postcode;
import com.example.epos_2021.models.PrepLocation;
import com.example.epos_2021.models.Printer;
import com.example.epos_2021.models.SiteSetting;
import com.example.epos_2021.models.Table;
import com.example.epos_2021.models.TableStatus;
import com.example.epos_2021.network.ApiEndPoints;
import com.example.epos_2021.online.fragments.EnterPasswordDialogFragment;
import com.example.epos_2021.services.SingleOrderUploaderService;
import com.example.epos_2021.utils.Constants;
import com.example.epos_2021.utils.LogUtils;
import com.example.epos_2021.utils.OnSwipeTouchListener;
import com.example.epos_2021.utils.ToastUtils;
import com.google.android.material.button.MaterialButton;
import com.google.android.material.card.MaterialCardView;
import com.google.android.material.chip.Chip;
import com.google.gson.Gson;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.concurrent.Callable;

/**
 * Created by Amrish on 17-05-2021.
 */
public class NewOrderActivity extends BaseActivity {

    private final ArrayList<OrderItem> orderItems = new ArrayList<>();
    private final ArrayList<Object> objects = new ArrayList<>();
    private final ArrayList<OrderButton> orderButtons = new ArrayList<>();
    private final ArrayList<CustomMenuItem> orderOptionsMenu = new ArrayList<>();
    private final boolean printAction = false;
    private final ArrayList<CustomMenuItem> orderActionMenu = new ArrayList<>();
    public WifiPrinter wifiPrinter;
    public TableStatus vacantStatus = myApp.findStatus("Vacant");
    public TableStatus takingOrderStatus = myApp.findStatus("Taking Order");
    public TableStatus orderTakenStatus = myApp.findStatus("Order Taken");
    public TableStatus servedStatus = myApp.findStatus("Served");
    public TableStatus servedPaidStatus = myApp.findStatus("Served and paid");
    FragmentManager manager;
    Order order = new Order();
    boolean orderCompleteAuto = false;
    CalllogViewModel calllogViewModel;
    boolean shouldFetchDeliveryCharge = false;
    boolean enableBackPress;
    float deliveryCharge = 0;
    boolean splitByPersonPrint = false;
    float printableTotal = 0;
    private Chip chipBack;
    private TextView tvPreviousScreen, tvCurrentScreen, tvTime;
    private EditText etSearch;
    private LinearLayout llDiscount, llGratuity, llServiceCharge, llDelivery, llSearch, llCustomerInfo;
    private TextView tvGratuity, tvServiceCharge, tvDelivery, tvEditQty, tvSwipeToRemove, tvDone, tvcustomer_contact, tvcustomer_detail;
    private MaterialButton btnCheckout, btnCancelOrder, btnCash, btnCard;
    private TextView tvInstruction;
    private LinearLayout llDelete, llCheckout;
    private SwipeLayout swipeLayout;
    private MaterialCardView cvInstructions;
    private TextView tvGratuityText, tvServiceChargeText, tvDiscountText;
    private LinearLayout llExpand, llGrandTotal;
    private ImageView ivExpand;
    private RecyclerView rvOrderItems, rvOrderAction;
    private MaterialCardView cvCallerId;
    private OrderItemsAdapter orderItemsAdapter;
    private Printer forceFullyDefaultPrinter;
    private ArrayList<Printer> printers = new ArrayList<>();
    //    private BroadcastReceiver callReceiver, orderItemReceiver, productItemClickReceiver, orderButtonClickReceiver, deleteOrderItemReciver;
    private TextView tvSubtotal, tvDiscount, tvGrandTotal, tvCallerName, tvCalleAddress, tvDeliveryText;
    private float cartGrandTotal = 0, cartSubTotal = 0, cartDiscount = 0, cartGratuity = 0, cartServiceCharge = 0;
    private LinearLayout llCustomerDetails;
    private LinearLayout llCallerId;
    private TextView tvCustomerDetails, tvCancelOrder;
    private RecyclerView rvOrderButtons;
    private OrderButtonsAdapter buttonsAdapter;
    private AlertDialog progressBarDialog;
    private Chip ivOrderOptions;
    private LinearLayout llOrderOptions, llOrderItems;
    private RecyclerView rvOrderOptions;
    private OrderOptionMenuAdapter orderOptionMenuAdapter, orderActionMenuAdapter;
    private Toolbar toolbar;
    private OrderWithItems orderWithItems;
    private TextView tvCallerNumber;
    private ImageView imgCancel, imgAccept, imgHold;
    private CallLogs callLogs;
    BroadcastReceiver callReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            callLogs = new Gson().fromJson(intent.getStringExtra("calllogs"), CallLogs.class);
            cvCallerId.setVisibility(View.VISIBLE);
            if (callLogs.customer != null) {
                Customer customer = callLogs.customer;
                if (!Validators.isNullOrEmpty(customer.name)) {
                    tvCallerName.setText(customer.name);
                } else {
                    tvCallerName.setText("");
                }
                StringBuilder sb = new StringBuilder();
                if (!Validators.isNullOrEmpty(customer.house_no)) {
                    sb.append(customer.house_no).append(", ");
                }
                if (!Validators.isNullOrEmpty(customer.street)) {
                    sb.append(customer.street).append("\n");
                }
                if (!Validators.isNullOrEmpty(customer.postcode)) {
                    sb.append(customer.postcode).append("\n");
                }

                if (!Validators.isNullOrEmpty(customer.city)) {
                    sb.append(customer.city).append("\n");
                }
                if (!Validators.isNullOrEmpty(customer.state)) {
                    sb.append(customer.state).append("\n");
                }
                if (!Validators.isNullOrEmpty(customer.distance)) {
                    sb.append(customer.distance).append(" Miles away");
                }

                if (!Validators.isNullOrEmpty(sb.toString())) {
                    tvCalleAddress.setText(sb.toString());
                } else {
                    tvCalleAddress.setText("");
                }

            } else {
                tvCallerName.setText("");
                tvCalleAddress.setText("");
            }
            tvCallerNumber.setText(callLogs.number);

        }
    };
    private int _order_id;
    private String order_id;
    private LinearLayout llMainLayout;
    private SiteSetting gratuityMainSetting, printAllMainSetting, printBillMainSetting, sendOrderMainSetting, sendOrderUpdateMainSetting, sendDupOrderMainSetting, sendDupOrderUpdateMainSetting, buzzerSetting, totalVisibilitySetting;
    private SiteSetting serviceChargeSetting, serviceChargeTypeSetting, serviceChargeEnableSetting, serviceChargeOptionSetting, ticketHeaderSetting,
            ticketHeaderTypeSetting, footerASetting, footerBSetting, orderDateTimeSetting, tableOrOrderIdSetting,
            sendOrderActionSetting, payBillActionSetting, payBillActionModeSetting, deliveryChargeTypeOption;
    private boolean serviceChargeAutoMode = true, serviceChargeVisible = false,
            serviceChargeEnabled = false, voucherPaymentsEnabled = false,
            discountEnabled = true, gratuityEnabled = true, autoDiscountApplied = false;
    private int headerAlignment = 0;
    private boolean printTotalInPrint = true;
    private ZoneRichPrinter zoneRichPrinter;
    private SunmiPrinter sunmiPrinter;
    private Printer defaultPrinter;
    private boolean needToUpload = true;
    BroadcastReceiver orderButtonClickReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            if (intent.getExtras().getBoolean("print_order")) {
                if (intent.getExtras().getBoolean("print_all")) {
                    createBillPrint("", true, false, false);
                    createBillPrint("", false, true, false);

//                    createBillPrint("Full Order", false, false, false);
                }
                if (intent.getExtras().getBoolean("print_bill")) {
                    createBillPrint("print_bill", false, true, false);
                }

               /* new UpdateOrderAsyncTask(() -> {

                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);*/
            }
            if (intent.getExtras().getBoolean("send_order")) {
                SendOrderDialogFragment sendOrderDialogFragment = SendOrderDialogFragment.getInstance(sendOrderMainSetting, sendOrderUpdateMainSetting, sendDupOrderMainSetting, sendDupOrderUpdateMainSetting);
                sendOrderDialogFragment.show(getSupportFragmentManager(), "send_order");
                sendOrderDialogFragment.setDialogDismissListener(o -> {
                    if (o instanceof String) {
                        order.order_action_id = (String) o;
                        new UpdateOrderAsyncTask(() -> {
                            if (sendOrderActionSetting != null && sendOrderActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                                if (order.order_action_id.equalsIgnoreCase("1")) {
                                    createPrint("Full Order", true, true, false);
                                } else if (order.order_action_id.equalsIgnoreCase("2")) {
                                    createPrint("Duplicate Order", true, true, false);
                                } else if (order.order_action_id.equalsIgnoreCase("3")) {
                                    createPrint("Updated Order", true, true, true);
                                } else if (order.order_action_id.equalsIgnoreCase("4")) {
                                    createPrint("Duplicate Updated Order", true, true, true);
                                } else {
                                    onBackPressed();
                                }
                            } else {
                                onBackPressed();
                            }
                            return null;
                        }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                    }
                });
            }

        }
    };
    private boolean voucherPaymentDone = true;
    private String destination;
    private String footerA, footerB;
    private String dateTimeModeInPrint;
    private Handler mHandler;
    private DialogDismissListener searchListerner;
    private boolean canEditOrder = false, callChangeTableStatus = true;
    private OrderSplit selectedSplit;
    private boolean shouldOpenSplitScreen = false;
    BroadcastReceiver orderItemReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            if (order != null) {
                if (!isValidToPlaceOrder()) return;
            }
            if (!canEditOrder) return;
            String order_item = intent.getStringExtra("order_item");
            if (!Validators.isNullOrEmpty(order_item)) {
                OrderItem orderItem = new Gson().fromJson(order_item, OrderItem.class);
                Log.e("OrderItem", ":" + orderItem.toString());
                new AddOrUpdateOrderItemAsyncTask(() -> {
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, orderItem);

            }
        }
    };
    BroadcastReceiver orderUpdateReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            if (intent.getBooleanExtra("result", false)) {
                int arg_order_id = intent.getIntExtra("_order_id", -1);
                if (arg_order_id == _order_id) {
                    fetchOffline(false);
                }
            }
        }
    };
    private String category_id;

    @Override
    protected void setXML() {
        super.setXML();
        setContentView(R.layout.fragment_new_order);
        manager = getSupportFragmentManager();
    }

    public void setSearchListener(DialogDismissListener searchListener) {
        this.searchListerner = searchListener;
    }

    @Override
    protected void manageIntents() {
        super.manageIntents();
        if (getIntent() != null) {
            order = new Gson().fromJson(getIntent().getStringExtra("order"), Order.class);
            Toast.makeText(this, "Order Type:" + order.order_type, Toast.LENGTH_SHORT).show();
            destination = getIntent().getStringExtra("destination");
            shouldFetchDeliveryCharge = getIntent().getBooleanExtra("fetch_delivery_charge", false);
            if (order != null && !Validators.isNullOrEmpty(order.order_status_id) && (order.order_status_id.equalsIgnoreCase("5") || order.order_status_id.equalsIgnoreCase("10"))) {
                needToUpload = false;
            }
            _order_id = getIntent().getIntExtra("orderId", -1);
            _order_id = getIntent().getIntExtra("_order_id", -1);
            order_id = getIntent().getStringExtra("order_id");
            if (order != null) {
                _order_id = order._id;
                order_id = order.id;
            } else {
                if (_order_id == -1 && order != null) {
                    _order_id = order._id;
                }
                if (Validators.isNullOrEmpty(order_id) && order != null) {
                    order_id = order.id;
                }
            }
        }
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        myApp.setOrderItems(new ArrayList<>());
        calllogViewModel = new ViewModelProvider(this).get(CalllogViewModel.class);
        setListeners();
        changeFragment(ProductAreaFragment.getInstance(order_id, _order_id), false);
        addCategoryFragment(MainCategoryFragment.getInstance());

        LocalBroadcastManager.getInstance(this).registerReceiver(orderItemReceiver, new IntentFilter(Constants.EPOS_CART_UPDATE));
        LocalBroadcastManager.getInstance(this).registerReceiver(orderButtonClickReceiver, new IntentFilter("order_button_click"));

        updateTime();
        printers = selectedBusiness.printers;

        Log.e("Abc", "" + shouldFetchDeliveryCharge);
        if (shouldFetchDeliveryCharge && deliveryChargeTypeOption.value.equals("auto")) {
            fetchDeliveryCharge(() -> {
                fetchOffline(true);
                return null;
            });
        } else {
            shouldFetchDeliveryCharge = order.order_type_id.equalsIgnoreCase("3");
            Log.e("Abc", "" + shouldFetchDeliveryCharge);

            if (shouldFetchDeliveryCharge)
                deliveryCharge = order.delivery_charge;

            fetchOffline(true);
        }

        if (defaultPrinter != null && (defaultPrinter.printer_model_name.toLowerCase().contains("pos-80") || defaultPrinter.printer_model_name.toLowerCase().contains("pos 80") || defaultPrinter.printer_model_name.toLowerCase().contains("yoke4"))) {
            wifiPrinter.connect(defaultPrinter.ip);
        }
    }

    private void addCategoryFragment(Fragment fragment) {
        FragmentManager manager = getSupportFragmentManager();
        FragmentTransaction transaction = manager.beginTransaction();
        transaction.replace(R.id.fl_main_category, fragment);
        transaction.commit();
    }

    @Override
    protected void initViews() {
        super.initViews();
        defaultPrinter = myPreferences.getDefaultPrinter();
        forceFullyDefaultPrinter = myPreferences.getDefaultPrinter(true);
        zoneRichPrinter = new ZoneRichPrinter(this);
        sunmiPrinter = new SunmiPrinter(this);
        wifiPrinter = WifiPrinter.getInstance();

        toolbar = findViewById(R.id.toolbar);
        progressBarDialog = CommonFunctions.customProgressDialog(this);
        ivOrderOptions = findViewById(R.id.ivOrderOptions);

        imgHold = findViewById(R.id.imgHold);
        imgCancel = findViewById(R.id.imgCancel);
        imgAccept = findViewById(R.id.imgAccept);
        tvCallerNumber = findViewById(R.id.tvCallerNumber);
        tvCallerName = findViewById(R.id.tvCallerName);
        tvCalleAddress = findViewById(R.id.tvCalleAddress);
        llCallerId = findViewById(R.id.llCallerId);
        cvCallerId = findViewById(R.id.cvCallerId);

        rvOrderItems = findViewById(R.id.rvSelectedProducts);

        llCustomerDetails = findViewById(R.id.llCustomerDetails);
        tvCustomerDetails = findViewById(R.id.tvCustomerDetails);
        tvCancelOrder = findViewById(R.id.tvCancelOrder);

        tvSubtotal = findViewById(R.id.tvSubtotal);
        tvDiscount = findViewById(R.id.tvDiscount);
        tvGrandTotal = findViewById(R.id.tvGrandTotal);
        tvDeliveryText = findViewById(R.id.tvDeliveryText);

        rvOrderButtons = findViewById(R.id.rvOrderButtons);
        llOrderOptions = findViewById(R.id.llOrderOptions);
        llOrderItems = findViewById(R.id.llOrderItems);
        rvOrderOptions = findViewById(R.id.rvOrderOptions);

        chipBack = findViewById(R.id.chipBack);
        tvPreviousScreen = findViewById(R.id.tvPreviousScreen);
        tvCurrentScreen = findViewById(R.id.tvCurrentScreen);
        etSearch = findViewById(R.id.etSearchMenu);
        tvTime = findViewById(R.id.tvTime);
        tvEditQty = findViewById(R.id.tvEditQty);
        tvSwipeToRemove = findViewById(R.id.tvRemove);
        tvDone = findViewById(R.id.tvDone);

        llDelivery = findViewById(R.id.ll_Delivery);
        llGratuity = findViewById(R.id.ll_Gratuity);
        llServiceCharge = findViewById(R.id.ll_ServiceCharge);
        llDiscount = findViewById(R.id.ll_Discount);
        llCustomerInfo = findViewById(R.id.llCustomerInfo);

        tvDelivery = findViewById(R.id.tvDelivery);
        tvGratuity = findViewById(R.id.tvGratuity);
        tvcustomer_contact = findViewById(R.id.tvcustomer_contact);
        tvcustomer_detail = findViewById(R.id.tvcustomer_detail);
        tvServiceCharge = findViewById(R.id.tvServiceFee);
        btnCheckout = findViewById(R.id.btnCheckout);
        llSearch = findViewById(R.id.llSearch);
        tvInstruction = findViewById(R.id.tvInstructions);
        llDelete = findViewById(R.id.llDelete);
        swipeLayout = findViewById(R.id.swipeRevealLayout);
        cvInstructions = findViewById(R.id.cvInstruction);
        tvDiscountText = findViewById(R.id.tvDiscountText);
        tvServiceChargeText = findViewById(R.id.tvServiceText);
        tvGratuityText = findViewById(R.id.tvGratuityText);
        llMainLayout = findViewById(R.id.drawer_layout);
        btnCancelOrder = findViewById(R.id.btnCancelOrder);
        btnCash = findViewById(R.id.btnCash);
        btnCard = findViewById(R.id.btnCard);
        llCheckout = findViewById(R.id.llCheckout);

        llGrandTotal = findViewById(R.id.llGrandTotal);
        llExpand = findViewById(R.id.llExpandable);
        ivExpand = findViewById(R.id.ivExpand);
        rvOrderAction = findViewById(R.id.rvOrderAction);

        llExpand.setVisibility(View.GONE);
        String currentTime = new SimpleDateFormat("h:mm a", Locale.getDefault()).format(new Date());
        tvTime.setText(currentTime);

        rvOrderButtons.setVisibility(View.GONE);
        btnCheckout.setVisibility(View.GONE);
        btnCard.setVisibility(View.GONE);
        btnCash.setVisibility(View.GONE);

        setSupportActionBar(toolbar);
        getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        getSupportActionBar().setTitle(" ");
        toolbar.setNavigationIcon(R.drawable.ic_baseline_arrow_back_24);
        loadSettings();
        setAdapters();
    }

    private void updateTime() {
        mHandler = new Handler();

        mHandler.postDelayed(new Runnable() {
            @Override
            public void run() {
                String currentTime = new SimpleDateFormat("hh:mm a", Locale.getDefault()).format(new Date());
                tvTime.setText(currentTime);
                mHandler.postDelayed(this, 1000);
            }
        }, 10);
    }

    private void loadSettings() {
        gratuityMainSetting = myApp.findSetting("gratuity");
        printAllMainSetting = myApp.findSetting("is_printall");
        printBillMainSetting = myApp.findSetting("is_printbill");
        buzzerSetting = myApp.findSetting("open_cash_drawer_after_send_to_kitchen");
        sendOrderMainSetting = myApp.findSetting("is_sendorder");
        sendOrderUpdateMainSetting = myApp.findSetting("is_sendorderupdate");
        sendDupOrderMainSetting = myApp.findSetting("is_sendduplicateorder");
        sendDupOrderUpdateMainSetting = myApp.findSetting("is_sendorderupdate");

        sendOrderActionSetting = myApp.findSetting("send_order_action");
        payBillActionSetting = myApp.findSetting("pay_bill_action");
        payBillActionModeSetting = myApp.findSetting("pay_bill_action_type");
        totalVisibilitySetting = myApp.findSetting("kitchen_total_visible");
        footerASetting = myApp.findSetting("footer_a");
        footerBSetting = myApp.findSetting("footer_b");
        orderDateTimeSetting = myApp.findSetting("date_time_in_receipt_printing");
        tableOrOrderIdSetting = myApp.findSetting("use_table_number_or_order_number");
        serviceChargeEnableSetting = myApp.findSetting("is_service_charge");

        serviceChargeSetting = myApp.findSetting("service_charge");
        serviceChargeOptionSetting = myApp.findSetting("service_charge_type_option");
        serviceChargeTypeSetting = myApp.findSetting("service_charge_type");
        deliveryChargeTypeOption = myApp.findSetting("delivery_charge_type_option");


        ticketHeaderTypeSetting = myApp.findSetting("ticket_header_type");
        if (ticketHeaderTypeSetting != null && ticketHeaderTypeSetting.value.equalsIgnoreCase("right")) {
            headerAlignment = 2;
        }
        if (ticketHeaderTypeSetting != null && ticketHeaderTypeSetting.value.equalsIgnoreCase("center")) {
            headerAlignment = 1;
        }
        ticketHeaderSetting = myApp.findSetting("ticket_header");

        if (serviceChargeEnableSetting != null && (serviceChargeEnableSetting.value.equalsIgnoreCase("true") || serviceChargeEnableSetting.value.equalsIgnoreCase("1"))) {
            serviceChargeEnabled = true;
            serviceChargeVisible = true;
        }
        if (serviceChargeEnabled && serviceChargeOptionSetting != null && serviceChargeOptionSetting.value.equalsIgnoreCase("manual")) {
            serviceChargeAutoMode = false;
 /*           Links.service_charges_mode = 1;
            Links.service_charges = false;*/
        } /*else {
            Links.service_charges_mode = 0;
            Links.service_charges = true;
        }*/

        if (footerASetting != null) {
            footerA = footerASetting.value;
        }
        if (footerBSetting != null) {
            footerB = footerBSetting.value;
        }
        if (orderDateTimeSetting != null) {
            dateTimeModeInPrint = orderDateTimeSetting.value;
        }
        if (totalVisibilitySetting != null && (totalVisibilitySetting.value.equalsIgnoreCase("no") || totalVisibilitySetting.value.equalsIgnoreCase("false") || totalVisibilitySetting.value.equalsIgnoreCase("0"))) {
            printTotalInPrint = false;
        }
        SiteSetting orderCompleteMode = myApp.findSetting("order_complete_mode");
        if (orderCompleteMode != null && !Validators.isNullOrEmpty(orderCompleteMode.value) && (orderCompleteMode.value.equalsIgnoreCase("auto") || orderCompleteMode.value.equalsIgnoreCase("1") || orderCompleteMode.value.equalsIgnoreCase("yes"))) {
            orderCompleteAuto = true;
        }
    }

    private void setAdapters() {

        //right side detail
        // Product item clicked
        //            editAddons(position,data);

        orderItemsAdapter = new OrderItemsAdapter(objects, (position, action, data) -> {
            if (data instanceof OrderItem) {
                editProduct(position, action, data);
            } else if (data instanceof OrderSplit) {
                OrderSplit split = (OrderSplit) data;
                if (split.selected) {
                    selectedSplit = split;
                } else {
                    selectedSplit = null;
                }
                new FetchOrderOfflineAsyncTask(() -> {
                    orderItemsAdapter.notifyDataSetChanged();
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            }
        }, (position, data) -> {
            if (data instanceof OrderItem) {
                // Product get deleted
                OrderItem orderItem = (OrderItem) data;
                boolean isReturn = false;
                if (!isValidToPlaceOrder()) isReturn = true;
                if (order.total_paid > 0) {
                    ToastUtils.showSnackBar(NewOrderActivity.this, llMainLayout, "Cannot change in paid order", "failed");
                    isReturn = true;
                }
                if (orderItem._order_split_id > 0 && selectedSplit.paid_amount > 0) {
                    ToastUtils.showSnackBar(NewOrderActivity.this, llMainLayout, "Cannot change in paid split group", "failed");
                    isReturn = true;
                }
                if (isReturn) {
                    new FetchOrderOfflineAsyncTask(() -> {
                        orderItemsAdapter.notifyDataSetChanged();
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                    return;
                }


                new Thread(() -> {
                    cartSubTotal = cartSubTotal - orderItem.total;
                    myApp.appDatabase.orderItemDao().delete(orderItem);
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }).start();
            }

        }, (position, data) -> {
            openOrderItemDetails((OrderItem) data);
        });
        rvOrderItems.setLayoutManager(new LinearLayoutManager(NewOrderActivity.this, LinearLayoutManager.VERTICAL, false));
        rvOrderItems.setAdapter(orderItemsAdapter);


        rvOrderButtons.setLayoutManager(new LinearLayoutManager(NewOrderActivity.this, RecyclerView.HORIZONTAL, false));
        buttonsAdapter = new OrderButtonsAdapter(this, orderButtons, (position, data) -> {
            OrderButton orderButton = (OrderButton) data;
            manageOrderActionsClick(orderButton);
        });
        rvOrderButtons.setAdapter(buttonsAdapter);


        rvOrderOptions.setLayoutManager(new LinearLayoutManager(NewOrderActivity.this, RecyclerView.VERTICAL, false));

        orderOptionMenuAdapter = new OrderOptionMenuAdapter(orderOptionsMenu, (position, data) -> {
            // Open dialogs here
            changeViewsVisibility(data);
        });

        rvOrderOptions.setAdapter(orderOptionMenuAdapter);

        orderActionMenuAdapter = new OrderOptionMenuAdapter(orderActionMenu, (position, data) -> {
            //manage click
            manageItemActionsClick(data);
        });
        rvOrderAction.setLayoutManager(new GridLayoutManager(this, 4));
        rvOrderAction.setAdapter(orderActionMenuAdapter);
    }

    private void manageItemActionsClick(Object data) {

        CustomMenuItem customMenuItem = (CustomMenuItem) data;

        if (customMenuItem.key.equalsIgnoreCase("send_order")) {
            SendOrderDialogFragment sendOrderDialogFragment = SendOrderDialogFragment.getInstance(sendOrderMainSetting, sendOrderUpdateMainSetting, sendDupOrderMainSetting, sendDupOrderUpdateMainSetting);
            sendOrderDialogFragment.show(getSupportFragmentManager(), "send_order");
            sendOrderDialogFragment.setDialogDismissListener(o -> {
                if (o instanceof String) {
                    order.order_action_id = (String) o;
                    new UpdateOrderAsyncTask(() -> {
                        if (sendOrderActionSetting != null && sendOrderActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                            if (order.order_action_id.equalsIgnoreCase("1")) {
                                createPrint("Full Order", true, true, false);
                            } else if (order.order_action_id.equalsIgnoreCase("2")) {
                                createPrint("Duplicate Order", true, true, false);
                            } else if (order.order_action_id.equalsIgnoreCase("3")) {
                                createPrint("Updated Order", true, true, true);
                            } else if (order.order_action_id.equalsIgnoreCase("4")) {
                                createPrint("Duplicate Updated Order", true, true, true);
                            } else {
                                onBackPressed();
                            }
                        } else {
                            onBackPressed();
                        }
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            });
        } else if (customMenuItem.key.equalsIgnoreCase("print_order")) {
            //print bill
            PrintOptionsDialogFragment printOptionsDialogFragment = PrintOptionsDialogFragment.getInstance(printBillMainSetting, printAllMainSetting);
            printOptionsDialogFragment.show(getSupportFragmentManager(), "print_options");
            printOptionsDialogFragment.setDialogDismissListener(o -> {
                if (o instanceof String) {
                    String action = (String) o;
                    if (action.equalsIgnoreCase("print_bill")) {
                        order.order_action_id = "5";
                    } else if (action.equalsIgnoreCase("print_bill")) {
                        order.order_action_id = "6";
                    }
                    new UpdateOrderStatusAsyncTask(() -> {
                        if (action.equalsIgnoreCase("print_bill")) {
                            createBillPrint("Full Order", false, true, false);
                        } else if (action.equalsIgnoreCase("print_all")) {
                            createBillPrint("", true, false, false);
                            createBillPrint("", false, true, false);
//                            createBillPrint("Full Order", false, false, false);
                        }
                        onBackPressed();
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);

                  /*  order.order_action_id = (String) o;
                    new UpdateOrderAsyncTask(() -> {
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);*/

                 /*   if (((String) o).equalsIgnoreCase("print_bill")) {
                        createPrint("Full Order", false, true, false);
                      //  createPrint("print_bill", false, true, false);
                    } else if (((String) o).equalsIgnoreCase("print_all")) {
                        createPrint("Full Order", true, false, false);
                        createPrint("Full Order", false, false, false);
                    }*/
                }
            });
        } else if (customMenuItem.key.equalsIgnoreCase("discount")) {
            if (!canEditOrder) return;
            llSearch.setVisibility(View.INVISIBLE);
            DiscountDialogFragment discountFragment = DiscountDialogFragment.getInstance(order._id, "Discount");
            changeFragment(discountFragment, true);
            discountFragment.setDialogDismissListener(o -> {
                if (!isValidToPlaceOrder()) return;

                if (o instanceof Float) {
                    cartDiscount = (float) o;
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        ToastUtils.showSnackBar(this, llMainLayout, "Discount has been added", "success");
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            });

        } else if (customMenuItem.key.equalsIgnoreCase("split")) {
            startActivityForResult(new Intent(NewOrderActivity.this, SplitActivity.class).putExtra("_order_id", order._id).putExtra("order_id", order.id), Constants.CODE_REFRESH);
        }

    }

    private void manageOrderActionsClick(OrderButton orderButton) {
        if (orderButton.key.equalsIgnoreCase("pay_bill")) {
            openPayBillScreen();
        } else if (orderButton.key.equalsIgnoreCase("send_order")) {
            SendOrderDialogFragment sendOrderDialogFragment = SendOrderDialogFragment.getInstance(sendOrderMainSetting, sendOrderUpdateMainSetting, sendDupOrderMainSetting, sendDupOrderUpdateMainSetting);
            sendOrderDialogFragment.show(getSupportFragmentManager(), "send_order");
            sendOrderDialogFragment.setDialogDismissListener(o -> {
                if (o instanceof String) {
                    order.order_action_id = (String) o;
                    new UpdateOrderAsyncTask(() -> {
                        if (sendOrderActionSetting != null && sendOrderActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                            if (order.order_action_id.equalsIgnoreCase("1")) {
                                createPrint("Full Order", true, true, false);
                            } else if (order.order_action_id.equalsIgnoreCase("2")) {
                                createPrint("Duplicate Order", true, true, false);
                            } else if (order.order_action_id.equalsIgnoreCase("3")) {
                                createPrint("Updated Order", true, true, true);
                            } else if (order.order_action_id.equalsIgnoreCase("4")) {
                                createPrint("Duplicate Updated Order", true, true, true);
                            } else {
                                onBackPressed();
                            }
                        } else {
                            onBackPressed();
                        }
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            });
        } else if (orderButton.key.equalsIgnoreCase("print_bill")) {
            new UpdateOrderAsyncTask(() -> {
                if (sendOrderActionSetting != null && sendOrderActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                    if (order.order_action_id.equalsIgnoreCase("1")) {
                        createPrint("Full Order", true, true, false);
                    } else if (order.order_action_id.equalsIgnoreCase("2")) {
                        createPrint("Duplicate Order", true, true, false);
                    } else if (order.order_action_id.equalsIgnoreCase("3")) {
                        createPrint("Updated Order", true, true, true);
                    } else if (order.order_action_id.equalsIgnoreCase("4")) {
                        createPrint("Duplicate Updated Order", true, true, true);
                    } else {
                        onBackPressed();
                    }
                } else {
                    onBackPressed();
                }
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            createPrint("print_bill", false, true, false);
        } else if (orderButton.key.equalsIgnoreCase("print_all")) {
          /*  new UpdateOrderAsyncTask(() -> {
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);*/

          /*  createPrint("Full Order", true, false, false);
            createPrint("Full Order", false, false, false);*/
            createPrint("", true, false, false);
            createPrint("", false, true, false);
//            createBillPrint("Full Order", false, false, false);
        } else if (orderButton.key.equalsIgnoreCase("cancel_order")) {
            cancelOrderAction();
        }
    }

    private void openOrderItemDetails(OrderItem data) {
        OrderItemViewDialogFragment orderItemViewDialogFragment = OrderItemViewDialogFragment.getInstance(data);
        orderItemViewDialogFragment.show(getSupportFragmentManager(), "show");
        orderItemViewDialogFragment.setCancelable(true);
    }

    private void changeViewsVisibility(Object data) {

        if (rvOrderOptions.getVisibility() == View.VISIBLE) {
            ivOrderOptions.setRotation(0);
            handleOrderSidebarItemClick(data);
        }
    }

    private void cancelOrderAction() {
        ConfirmationDialogFragment confirmationDialogFragment = ConfirmationDialogFragment.getInstance("Cancel order", "Are you sure you want to cancel this order?", 2, "Confim", "Cancel");
        confirmationDialogFragment.show(getSupportFragmentManager(), "cancel_order_menu");
        confirmationDialogFragment.setDialogDismissListener(o -> {
            if (o instanceof String && ((String) o).equalsIgnoreCase("confirm")) {

                if (order.total_paid > 0) {
                    EnterPasswordDialogFragment enterPasswordDialogFragment = EnterPasswordDialogFragment.getInstance(null, "Please enter password", "Please enter password to cancel this order");
                    enterPasswordDialogFragment.show(getSupportFragmentManager(), "password");
                    enterPasswordDialogFragment.setDialogDismissListener(o1 -> {
                        if (o1 instanceof String) {
                            String password = (String) o1;
                            if (password.equalsIgnoreCase(myPreferences.getLoggedInUser().password)) {
                                order.order_status = "Order Rejected";
                                order.order_status_id = "10";
                                ToastUtils.showSnackBar(this, llMainLayout, "Order rejected", "reject");
                                new UpdateOrderAsyncTask(() -> {
                                    onBackPressed();
                                    return null;
                                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                            } else {
                                ToastUtils.makeSnackToast(NewOrderActivity.this, "Incorrect password");
                            }
                        }
                    });
                } else {
                    order.order_status = "Order Rejected";
                    order.order_status_id = "10";
                    ToastUtils.showSnackBar(this, llMainLayout, "Order rejected", "reject");
                    new UpdateOrderAsyncTask(() -> {
                        onBackPressed();
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            }
        });
    }

    private void initOrderSidebar() {

        orderOptionsMenu.clear();
        if (shouldFetchDeliveryCharge && deliveryChargeTypeOption.value.equals("manual")) {
            Log.e("Type_option_size", " Applied");
            orderOptionsMenu.add(new CustomMenuItem("DELIVERY CHARGES", "deliveryChargeType"));
        }
        if (MyApp.userPermission != null && MyApp.userPermission.misc.actions.list && canEditOrder)
            orderOptionsMenu.add(new CustomMenuItem("MISC", "misc"));
        if (gratuityMainSetting != null && (gratuityMainSetting.value.equalsIgnoreCase("true") || gratuityMainSetting.value.equalsIgnoreCase("1")) && (MyApp.userPermission != null && MyApp.userPermission.gratutity.actions.list) && gratuityEnabled && canEditOrder)
            orderOptionsMenu.add(new CustomMenuItem("GRATUITY", "gratuity"));
        if (serviceChargeEnabled && !serviceChargeAutoMode && canEditOrder) {
            orderOptionsMenu.add(new CustomMenuItem("SERVICE CHARGE", "service_charge"));
        }
        if (MyApp.userPermission != null && MyApp.userPermission.customer_info.actions.list)
            orderOptionsMenu.add(new CustomMenuItem("CUSTOMER INFO", "customer_info"));
//        if (MyApp.userPermission != null && MyApp.userPermission.split_bill.actions.list && (order.total_paid == 0 || !Validators.isNullOrEmpty(order.split_type)))
//            orderOptionsMenu.add(new CustomMenuItem("SPLIT", "split"));
//        if (MyApp.userPermission != null && MyApp.userPermission.discount.actions.list && discountEnabled && !autoDiscountApplied)
//            orderOptionsMenu.add(new CustomMenuItem("DISCOUNT", "discount"));
        if (voucherPaymentsEnabled && canEditOrder)
            orderOptionsMenu.add(new CustomMenuItem("VOUCHER", "voucher"));
        if (MyApp.userPermission != null && MyApp.userPermission.convert_order.actions.list && !voucherPaymentDone && canEditOrder)
            orderOptionsMenu.add(new CustomMenuItem("CONVERT ORDER", "convert_order"));
        if (order.order_type_id.equalsIgnoreCase("1") && (MyApp.userPermission != null && MyApp.userPermission.swap_table.actions.list)) {
            orderOptionsMenu.add(new CustomMenuItem("SWAP TABLE", "swap_table"));
        }
        if (MyApp.userPermission != null && MyApp.userPermission.comment.actions.list)
            orderOptionsMenu.add(new CustomMenuItem("ADD INSTRUCTIONS", "add_comment"));
        if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
            orderOptionsMenu.add(new CustomMenuItem("COMPLETE ORDER", "complete_order"));


        runOnUiThread(() -> {
            orderOptionMenuAdapter.notifyDataSetChanged();
        });
    }

    private void initOrderBottombar() {
        orderButtons.clear();

        if (MyApp.userPermission != null && MyApp.userPermission.cancel_order.actions.list) {
            if (order.total_paid > 0 && MyApp.userPermission.cancel_order_after_payment.actions.list) {
                btnCancelOrder.setVisibility(View.VISIBLE);
                orderButtons.add(new OrderButton("Cancel order", "cancel_order"));
            } else if (order.total_paid == 0) {
                btnCancelOrder.setVisibility(View.VISIBLE);
                orderButtons.add(new OrderButton("Cancel order", "cancel_order"));
            } else {
                btnCancelOrder.setVisibility(View.GONE);
            }
        } else {
            btnCancelOrder.setVisibility(View.GONE);
        }
        buttonsAdapter.notifyDataSetChanged();
    }

    private void updateViews() {
        if (order != null && order.customer != null) {
            Customer customer = order.customer;
            StringBuilder customerDetails = new StringBuilder();
            customerDetails.append(customer.name);
            if (!Validators.isNullOrEmpty(customer.mobile)) {
                customerDetails.append("\n");
                customerDetails.append(customer.mobile);
            }
            if (!Validators.isNullOrEmpty(customer.email)) {
                customerDetails.append("\n");
                customerDetails.append(customer.email);
            }
            if (order.order_type_id.equalsIgnoreCase("3")) {
                customerDetails.append("\n");
                StringBuilder addressBuilder = new StringBuilder();
                if (!Validators.isNullOrEmpty(customer.house_no)) {
                    addressBuilder.append(customer.house_no);
                }
                if (!Validators.isNullOrEmpty(customer.street)) {
                    if (addressBuilder.toString().length() > 0) {
                        addressBuilder.append(", ");
                    }
                    addressBuilder.append(customer.street);
                }
                if (!Validators.isNullOrEmpty(customer.city)) {
                    if (addressBuilder.toString().length() > 0) {
                        addressBuilder.append(", ");
                    }
                    addressBuilder.append(customer.city);
                }
                if (!Validators.isNullOrEmpty(customer.postcode)) {
                    if (addressBuilder.toString().length() > 0) {
                        addressBuilder.append(", ");
                    }
                    addressBuilder.append(customer.postcode);
                }
                customerDetails.append(addressBuilder.toString());
            }
            if (customer.selectedTable != null) {
                customerDetails.append("\n");
                customerDetails.append("Table No: ");
                customerDetails.append(customer.selectedTable.number);
                customerDetails.append("\n");
                customerDetails.append("No of guests: ");
                customerDetails.append(customer.no_guest);
            }
            tvCustomerDetails.setText("Customer details: " + customerDetails.toString());
            initOrderBottombar();
            initOrderSidebar();
            if (!Validators.isNullOrEmpty(order.comment)) {
                cvInstructions.setVisibility(View.VISIBLE);
                tvInstruction.setText("Instructions: " + order.comment);
            } else {
                cvInstructions.setVisibility(View.GONE);
            }
        } else {
            llCustomerDetails.setVisibility(View.GONE);
        }
        if (!Validators.isNullOrEmpty(order.order_type))
            tvCurrentScreen.setText("> " + order.order_type);

        if (MyApp.userPermission != null && MyApp.userPermission.order_option.actions.list) {
            ivOrderOptions.setVisibility(View.VISIBLE);
        } else {
            ivOrderOptions.setVisibility(View.GONE);
        }
        setCheckoutButtons();
        setCartValues();
        initOrderSidebarAction();
    }

    private void setCheckoutButtons() {
        if (myApp.isConnected(this)) {
            List<String> ids = new ArrayList<>();
            ids.add("2");
            if (selectedBusiness.merchant_service) {
                ids.add("9");
                ids.add("10");
            }
            new Thread(() -> {
                ArrayList<PaymentMethod> pMethods = new ArrayList<>(appDatabase.paymentMethodDao().list(ids));
                PaymentMethod cashPaymentMethod = appDatabase.paymentMethodDao().view("1");
                CommonFunctions.functionThatDelay(100);
                runOnUiThread(() -> {
                    if (MyApp.userPermission != null && MyApp.userPermission.pay_bill.actions.list && order.total > 0 && CommonFunctions.orderPaymentStatus(order.total, order.total_paid) != 1) {
                        llCheckout.setVisibility(View.VISIBLE);
                    } else {
                        llCheckout.setVisibility(View.GONE);
                    }
                    if (!cashPaymentMethod.disabled)
                        btnCash.setVisibility(View.VISIBLE);
                    if (pMethods.size() > 0) {
                        btnCard.setVisibility(View.VISIBLE);
                    }
                });
            }).start();
        } else {
            runOnUiThread(() -> {
                btnCash.setVisibility(View.VISIBLE);
                btnCard.setVisibility(View.GONE);
                if (MyApp.userPermission != null && MyApp.userPermission.pay_bill.actions.list && order.total > 0 && CommonFunctions.orderPaymentStatus(order.total, order.total_paid) != 1) {
                    llCheckout.setVisibility(View.VISIBLE);
                } else {
                    llCheckout.setVisibility(View.GONE);
                }
            });
        }
    }

    private void initOrderSidebarAction() {
        orderActionMenu.clear();

        boolean showPrintButton = false;
        if (MyApp.userPermission != null && (MyApp.userPermission.print_all.actions.list || MyApp.userPermission.print_bill.actions.list)) {
            if (printBillMainSetting == null && printAllMainSetting == null) {
                showPrintButton = false;
            } else
                showPrintButton = (printBillMainSetting == null || (!printBillMainSetting.value.equalsIgnoreCase("false") && !printBillMainSetting.value.equalsIgnoreCase("0"))) || (printAllMainSetting == null || (!printAllMainSetting.value.equalsIgnoreCase("false") && !printAllMainSetting.value.equalsIgnoreCase("0")));
        }
        if (MyApp.userPermission != null && MyApp.userPermission.send_order.actions.list && showSendOrderButton())
            orderActionMenu.add(new CustomMenuItem("Send", "send_order", R.drawable.ic_send));

        if (showPrintButton)
            orderActionMenu.add(new CustomMenuItem("Print", "print_order", R.drawable.ic_baseline_print_24));

        if (MyApp.userPermission != null && MyApp.userPermission.discount.actions.list && discountEnabled && !autoDiscountApplied && canEditOrder)
            orderActionMenu.add(new CustomMenuItem("Discount", "discount", R.drawable.icon_percentage));

        if (MyApp.userPermission != null && MyApp.userPermission.split_bill.actions.list && (order.total_paid == 0 || !Validators.isNullOrEmpty(order.split_type)) && canEditOrder)
            orderActionMenu.add(new CustomMenuItem("Split", "split", R.drawable.icon_split));
        if (orderActionMenu.size() > 0)
            rvOrderAction.setLayoutManager(new GridLayoutManager(this, orderActionMenu.size()));
        else rvOrderAction.setLayoutManager(new GridLayoutManager(this, 1));
        orderActionMenuAdapter.notifyDataSetChanged();
    }

    private void setListeners() {
        btnCancelOrder.setOnClickListener(view -> {
            cancelOrderAction();
        });

        llDelete.setOnClickListener(v -> {
            swipeLayout.close(true);
            order.comment = null;
            new UpdateOrderAsyncTask(() -> {
                fetchOffline(false);
                ToastUtils.showSnackBar(this, llMainLayout, "Instruction has been removed", "remove");
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        });

        tvDiscountText.setOnClickListener(v -> {
            if (!canEditOrder) return;
            cartDiscount = 0;
            new UpdateOrderAsyncTask(() -> {
                fetchOffline(false);
                ToastUtils.showSnackBar(this, llMainLayout, "Discount has been removed", "remove");
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        });
        tvServiceChargeText.setOnClickListener(v -> {
            if (!canEditOrder)
                return;

        /*    if (Links.service_charges_mode == 0) {
                Links.service_charges = false;
                serviceChargeEnabled = false;
            }*/

            cartServiceCharge = 0;
            new UpdateOrderAsyncTask(() -> {
                fetchOffline(false);
                ToastUtils.showSnackBar(this, llMainLayout, "Service charge has been removed", "remove");
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        });

        tvGratuityText.setOnClickListener(v -> {
            cartGratuity = 0;
            new UpdateOrderAsyncTask(() -> {
                fetchOffline(false);
                ToastUtils.showSnackBar(this, llMainLayout, "Gratuity has been removed", "remove");
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        });

        tvDeliveryText.setOnClickListener(v -> {
            deliveryCharge = 0;
            new UpdateOrderAsyncTask(() -> {
                fetchOffline(false);
                ToastUtils.showSnackBar(this, llMainLayout, "Delivery Charges has been removed", "remove");
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        });

        chipBack.setOnClickListener(v -> onBackPressed());

        etSearch.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {

            }

            @Override
            public void afterTextChanged(Editable editable) {

                if (searchListerner != null) {
                    searchListerner.onDialogDismiss(etSearch.getText().toString());
                }
                LocalBroadcastManager.getInstance(NewOrderActivity.this).sendBroadcast(new Intent("search_category").putExtra("searched_item", etSearch.getText().toString()));
            }
        });

        etSearch.setOnKeyListener((textView, i, keyEvent) -> {
            if (keyEvent.getKeyCode() == KeyEvent.KEYCODE_BACK) {
                onBackPressed();
            } else if ((keyEvent.getKeyCode() == KeyEvent.KEYCODE_ENTER)) {

                if (searchListerner != null) {
                    searchListerner.onDialogDismiss(etSearch.getText().toString());
                }
                LocalBroadcastManager.getInstance(NewOrderActivity.this).sendBroadcast(new Intent("search_category").putExtra("searched_item", etSearch.getText().toString()));
                CommonFunctions.hideKeyboard(this, etSearch);
            }
            return false;
        });

        tvEditQty.setOnClickListener(v -> {
            orderItemsAdapter.shouldEdit = true;
            orderItemsAdapter.notifyDataSetChanged();
            tvDone.setVisibility(View.VISIBLE);
            tvEditQty.setVisibility(View.INVISIBLE);
            tvSwipeToRemove.setVisibility(View.GONE);
        });

        tvDone.setOnClickListener(v -> {
            orderItemsAdapter.shouldEdit = false;
            orderItemsAdapter.notifyDataSetChanged();
            tvDone.setVisibility(View.GONE);
            tvEditQty.setVisibility(View.VISIBLE);
            tvSwipeToRemove.setVisibility(View.VISIBLE);
        });
        btnCheckout.setOnClickListener(v -> {
            if (!Validators.isNullOrEmpty(order.split_type) && shouldOpenSplitScreen) {
                startActivityForResult(new Intent(NewOrderActivity.this, SplitActivity.class).putExtra("_order_id", order._id).putExtra("order_id", order.id), Constants.CODE_REFRESH);
            } else {
                Intent intent = new Intent(NewOrderActivity.this, OrderReviewActivity.class);
                intent.putExtra("order_id", order.id)
                        .putExtra("_order_id", order._id)
                        .putExtra("order_total", order.total)
                        .putExtra("paid_amount", order.total_paid)
                        .putExtra("cart_service_charge", cartServiceCharge)
                        .putExtra("cart_discount", cartDiscount)
                        .putExtra("cart_gratuity", cartGratuity)
                        .putExtra("cart_grand_total", cartGrandTotal);
                if (selectedSplit != null) {
                    intent.putExtra("_order_split_id", selectedSplit._id);
                }
                startActivityForResult(intent, Constants.CODE_REFRESH);
            }
        });
        btnCard.setOnClickListener(v -> {
            PaymentMethod cardMethod = new PaymentMethod();
            cardMethod.id = "cc";
            cardMethod.name = "Card";

            if (!Validators.isNullOrEmpty(order.split_type) && shouldOpenSplitScreen) {
                startActivityForResult(new Intent(NewOrderActivity.this, SplitActivity.class).putExtra("payment_method", new Gson().toJson(cardMethod)).putExtra("_order_id", order._id).putExtra("order_id", order.id), Constants.CODE_REFRESH);
            } else {
                Intent intent = new Intent(NewOrderActivity.this, OrderReviewActivity.class);
                intent.putExtra("order_id", order.id)
                        .putExtra("_order_id", order._id)
                        .putExtra("order_total", order.total)
                        .putExtra("paid_amount", order.total_paid)
                        .putExtra("cart_service_charge", cartServiceCharge)
                        .putExtra("cart_discount", cartDiscount)
                        .putExtra("cart_gratuity", cartGratuity)
                        .putExtra("cart_grand_total", cartGrandTotal)
                        .putExtra("payment_method", new Gson().toJson(cardMethod));
                if (selectedSplit != null) {
                    intent.putExtra("_order_split_id", selectedSplit._id);
                }
                startActivityForResult(intent, Constants.CODE_REFRESH);
            }
        });
        btnCash.setOnClickListener(v -> {
            PaymentMethod cashMethod = new PaymentMethod();
            cashMethod.id = "1";
            cashMethod.name = "Cash";

            if (!Validators.isNullOrEmpty(order.split_type) && shouldOpenSplitScreen) {
                startActivityForResult(new Intent(NewOrderActivity.this, SplitActivity.class).putExtra("payment_method", new Gson().toJson(cashMethod)).putExtra("_order_id", order._id).putExtra("order_id", order.id), Constants.CODE_REFRESH);
            } else {
                Intent intent = new Intent(NewOrderActivity.this, OrderReviewActivity.class);
                intent.putExtra("order_id", order.id)
                        .putExtra("_order_id", order._id)
                        .putExtra("order_total", order.total)
                        .putExtra("paid_amount", order.total_paid)
                        .putExtra("cart_service_charge", cartServiceCharge)
                        .putExtra("cart_discount", cartDiscount)
                        .putExtra("cart_gratuity", cartGratuity)
                        .putExtra("cart_grand_total", cartGrandTotal)
                        .putExtra("payment_method", new Gson().toJson(cashMethod));
                if (selectedSplit != null) {
                    intent.putExtra("_order_split_id", selectedSplit._id);
                }
                startActivityForResult(intent, Constants.CODE_REFRESH);
            }
        });
        calllogViewModel.getCallLogs().observe(this, item -> {
            callLogs = item;
            cvCallerId.setVisibility(View.VISIBLE);
            if (callLogs.customer != null) {
                Customer customer = callLogs.customer;
                if (!Validators.isNullOrEmpty(customer.name)) {
                    tvCallerName.setText(customer.name);
                } else {
                    tvCallerName.setText("");
                }
                StringBuilder sb = new StringBuilder();
                if (!Validators.isNullOrEmpty(customer.house_no)) {
                    sb.append(customer.house_no).append(", ");
                }
                if (!Validators.isNullOrEmpty(customer.street)) {
                    sb.append(customer.street).append("\n");
                }
                if (!Validators.isNullOrEmpty(customer.postcode)) {
                    sb.append(customer.postcode).append("\n");
                }

                if (!Validators.isNullOrEmpty(customer.city)) {
                    sb.append(customer.city).append("\n");
                }
                if (!Validators.isNullOrEmpty(customer.state)) {
                    sb.append(customer.state).append("\n");
                }
                if (!Validators.isNullOrEmpty(customer.distance)) {
                    sb.append(customer.distance).append(" Miles away");
                }

                if (!Validators.isNullOrEmpty(sb.toString())) {
                    tvCalleAddress.setText(sb.toString());
                } else {
                    tvCalleAddress.setText("");
                }

            } else {
                tvCallerName.setText("");
                tvCalleAddress.setText("");
            }
            tvCallerNumber.setText(callLogs.number);
        });
        llCallerId.setOnTouchListener(new OnSwipeTouchListener(NewOrderActivity.this) {
            @Override
            public void onSwipeLeft() {
                super.onSwipeLeft();
                changeStatusCallerid("parked");
            }

            @Override
            public void onSwipeRight() {
                super.onSwipeRight();
                changeStatusCallerid("parked");
            }

            @Override
            public void onSwipeBottom() {
                super.onSwipeBottom();
                changeStatusCallerid("parked");
            }

            @Override
            public void onSwipeTop() {
                super.onSwipeTop();
                changeStatusCallerid("parked");
            }

        });

        imgAccept.setOnClickListener(v -> changeStatusCallerid("accepted"));
        imgCancel.setOnClickListener(v -> changeStatusCallerid("rejected"));
        imgHold.setOnClickListener(v -> changeStatusCallerid("parked"));


        ivOrderOptions.setOnClickListener(view -> {
            if (rvOrderItems.getVisibility() == View.VISIBLE) {
                rvOrderItems.setVisibility(View.GONE);
                tvEditQty.setVisibility(View.GONE);
                tvSwipeToRemove.setVisibility(View.GONE);
                llOrderOptions.setVisibility(View.VISIBLE);
                cvInstructions.setVisibility(View.GONE);
                tvDone.setVisibility(View.GONE);
                ivOrderOptions.setRotation(180);
            } else {
                if (llOrderOptions.getVisibility() == View.VISIBLE) {
                    llOrderOptions.setVisibility(View.GONE);
                    rvOrderItems.setVisibility(View.VISIBLE);
                    tvEditQty.setVisibility(View.VISIBLE);
                    orderItemsAdapter.shouldEdit = false;
                    orderItemsAdapter.notifyDataSetChanged();
                    tvSwipeToRemove.setVisibility(View.VISIBLE);
                    if (!Validators.isNullOrEmpty(order.comment)) {
                        cvInstructions.setVisibility(View.VISIBLE);
                    }
                    ivOrderOptions.setRotation(0);
                }
            }
        });


        llGrandTotal.setOnClickListener(view -> {
            if (llExpand.getVisibility() == View.VISIBLE) {
                ivExpand.setRotation(90);
                llExpand.setVisibility(View.GONE);
            } else {
                ivExpand.setRotation(270);
                llExpand.setVisibility(View.VISIBLE);
            }

        });
    }

    private void handleOrderSidebarItemClick(Object data) {
        CustomMenuItem customMenuItem = (CustomMenuItem) data;

        if (customMenuItem.key.equalsIgnoreCase("discount")) {
            if (!canEditOrder) return;
            llSearch.setVisibility(View.INVISIBLE);
            DiscountDialogFragment discountFragment = DiscountDialogFragment.getInstance(order._id, "Discount");
            changeFragment(discountFragment, true);
            discountFragment.setDialogDismissListener(o -> {
                if (!isValidToPlaceOrder()) return;

                if (o instanceof Float) {
                    cartDiscount = (float) o;
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        ToastUtils.showSnackBar(this, llMainLayout, "Discount has been added", "success");
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            });
        } else if (customMenuItem.key.equalsIgnoreCase("add_comment")) {
            llSearch.setVisibility(View.INVISIBLE);
            AddCommentFragment addCommentFragment = AddCommentFragment.getInstance(order.comment);
            changeFragment(addCommentFragment, true);
            addCommentFragment.setDialogDismissListener(o -> {
                if (!isValidToPlaceOrder()) return;
                order.comment = (String) o;
                new UpdateOrderAsyncTask(() -> {
                    fetchOffline(false);
                    if (!Validators.isNullOrEmpty(order.comment))
                        ToastUtils.showSnackBar(this, llMainLayout, "Instructions has been added", "success");
                    else
                        ToastUtils.showSnackBar(this, llMainLayout, "Instructions has been removed", "remove");

                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            });
        } else if (customMenuItem.key.equalsIgnoreCase("customer_info")) {
            if (order.order_type_id.equalsIgnoreCase("1")) {
                if (Validators.isNullOrEmpty(order.no_guest)) {
                    order.customer.no_guest = 0;
                } else {
                    order.customer.no_guest = Integer.parseInt(order.no_guest);
                }
                Table table = new Table();
                table.id = order.table_id;
                table.number = order.table_number;
                order.customer.selectedTable = table;
            }
            CustomerInfoDialogFragment newOrderDialogFragment = CustomerInfoDialogFragment.getInstance(order.customer, order.order_type_id);
            newOrderDialogFragment.show(getSupportFragmentManager(), "customer_info");
            newOrderDialogFragment.setDialogDismissListener(o -> {
                if (o instanceof Customer) {
                    new UpdateCustomerAsynTask(() -> {
                        Log.e("CustomerInfo", "customer_info");
                        fetchDeliveryCharge(() -> {
                            fetchOffline(true);
                            return null;
                        });
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, (Customer) o);
                }
            });
        } else if (customMenuItem.key.equalsIgnoreCase("cancel_order")) {
            CancelOrderDialogFragment cancelOrderDialogFragment = CancelOrderDialogFragment.getInstance();
            cancelOrderDialogFragment.show(getSupportFragmentManager(), "cancel_order_menu");
        } else if (customMenuItem.key.equalsIgnoreCase("gratuity")) {
            if (!canEditOrder) return;
            llSearch.setVisibility(View.INVISIBLE);
            DiscountDialogFragment gratuityFragment = DiscountDialogFragment.getInstance(order._id, "Gratuity");
            changeFragment(gratuityFragment, true);
            gratuityFragment.setDialogDismissListener(o -> {
                if (!isValidToPlaceOrder()) return;
                if (o instanceof Float) {
                    cartGratuity = (float) o;
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        ToastUtils.showSnackBar(this, llMainLayout, "Gratuity has been added", "success");
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            });

        } else if (customMenuItem.key.equalsIgnoreCase("voucher")) {
            if (!canEditOrder) return;
            llSearch.setVisibility(View.INVISIBLE);
            PaymentViaVoucherFragment viaVoucherFragment = PaymentViaVoucherFragment.getInstance(order);
            changeFragment(viaVoucherFragment, true);
            viaVoucherFragment.setDialogDismissListener(o -> {

                if (o instanceof String) {
                    if (((String) o).equalsIgnoreCase("confirm")) {
                        ToastUtils.showSnackBar(this, llMainLayout, "Voucher has been applied", "success");
                        new FetchOrderOfflineAsyncTask(() -> {
                            updateViews();
                            afterPaymentPrintOptions();
                            return null;
                        }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                    }
                }
            });

        } else if (customMenuItem.key.equalsIgnoreCase("service_charge")) {
            if (!canEditOrder)
                return;
            llSearch.setVisibility(View.INVISIBLE);
            DiscountDialogFragment serviceChargeFragment = DiscountDialogFragment.getInstance(order._id, "Service Charge");
            changeFragment(serviceChargeFragment, true);
            serviceChargeFragment.setDialogDismissListener(o -> {
                if (!isValidToPlaceOrder()) return;
                if (o instanceof Float) {
                    cartServiceCharge = (float) o;
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        ToastUtils.showSnackBar(this, llMainLayout, "Service charge has been added", "success");
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            });

        } else if (customMenuItem.key.equalsIgnoreCase("misc")) {
            if (!canEditOrder) return;
            llSearch.setVisibility(View.INVISIBLE);
            MiscItemFragment miscItemFragment = MiscItemFragment.getInstance();
            changeFragment(miscItemFragment, true);
            miscItemFragment.setDialogDismissListener(o -> {
                if (o instanceof OrderItem) {
                    LogUtils.e("ORDER::", "Misc Received");
                    LogUtils.e(o);
                    myApp.notifyCart(this, new Intent(Constants.EPOS_CART_UPDATE).putExtra("order_item", new Gson().toJson(o)));
                }
            });
        } else if (customMenuItem.key.equalsIgnoreCase("swap_table")) {
            if (!canEditOrder) return;
            AssignTableDialogFragment assignTableDialogFragment = AssignTableDialogFragment.getInstance("Swap Table", true, order.table_id);
            assignTableDialogFragment.show(getSupportFragmentManager(), "assign_table");
            assignTableDialogFragment.setDialogDismissListener(o -> {
                if (o instanceof Table) {
                    freeOldTable(order.table_id);
                    Table swappedTable = (Table) o;
                    order.table_number = swappedTable.number;
                    order.table_id = swappedTable.id;
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        lockTable(order, null, true);
                        changeTableStatus(order, orderTakenStatus.id, "Order Taken");
                        callChangeTableStatus = false;
                        onBackPressed();
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            });
        } else if (customMenuItem.key.equalsIgnoreCase("split")) {
            startActivityForResult(new Intent(NewOrderActivity.this, SplitActivity.class).putExtra("_order_id", order._id).putExtra("order_id", order.id), Constants.CODE_REFRESH);
        } else if (customMenuItem.key.equalsIgnoreCase("convert_order")) {
            if (!canEditOrder) return;
            ConvertOrderTypeFragment convertOrderTypeFragment = ConvertOrderTypeFragment.getInstance(order.order_type_id);
            changeFragment(convertOrderTypeFragment, true);
            convertOrderTypeFragment.setDialogDismissListener(o -> {
                if (o instanceof String) {

                    String orderTypeId = (String) o;
                    if (!orderTypeId.equalsIgnoreCase(order.order_type_id)) {
                        order.delivery_charge = 0;

                        if (order.order_type_id.equalsIgnoreCase("1")) {
                            changeTableStatusToFree(order.table_id);
                            order.order_type_id = orderTypeId;
                        }
                        if (orderTypeId.equalsIgnoreCase("1")) {
                            AssignTableDialogFragment assignTableDialogFragment = AssignTableDialogFragment.getInstance("Select Table", true, order.table_id);
                            assignTableDialogFragment.show(getSupportFragmentManager(), "assign_table");
                            assignTableDialogFragment.setDialogDismissListener(t -> {
                                if (t instanceof Table) {
                                    Table swappedTable = (Table) t;
                                    order.table_id = swappedTable.id;
                                    order.no_guest = "1";
                                    order.order_type_id = orderTypeId;
                                    lockTable(order, swappedTable, true);
                                    new UpdateOrderAsyncTask(() -> {
                                        changeTableStatus(order, takingOrderStatus.id, "Taking Order");
                                        callChangeTableStatus = false;
                                        onBackPressed();
                                        return null;
                                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                                }
                            });
                        } else if (orderTypeId.equalsIgnoreCase("3")) {
                            CustomerInfoDialogFragment newOrderDialogFragment = CustomerInfoDialogFragment.getInstance(order.customer, "3");
                            newOrderDialogFragment.show(getSupportFragmentManager(), "customer_info");
                            newOrderDialogFragment.setDialogDismissListener(c -> {
                                if (c instanceof Customer) {
                                    order.order_type_id = orderTypeId;
                                    new UpdateCustomerAsynTask(() -> {
                                        Log.e(" CustomerInfo", "3");
                                        onBackPressed();
                                        return null;
                                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, (Customer) c);
                                }
                            });
                        } else {
                            order.order_type_id = orderTypeId;
                            new UpdateOrderAsyncTask(() -> {
                                onBackPressed();
                                return null;
                            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                        }

                    }
                }
            });
        } else if (customMenuItem.key.equalsIgnoreCase("complete_order")) {
            order.order_status_id = "5";
            order.order_status = "Order Completed";
            new UpdateOrderAsyncTask(() -> {
                onBackPressed();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        } else if (customMenuItem.key.equalsIgnoreCase("deliveryChargeType")) {
            Log.e("deliveryChargeType", " " + customMenuItem.title);

            if (!canEditOrder)
                return;

            llSearch.setVisibility(View.INVISIBLE);
            DiscountDialogFragment gratuityFragment = DiscountDialogFragment.getInstance(order._id, "deliveryChargeType");
            changeFragment(gratuityFragment, true);
            gratuityFragment.setDialogDismissListener(o -> {
                if (!isValidToPlaceOrder()) return;
                if (o instanceof Float) {
                    deliveryCharge = (float) o;
                    Log.e("deliveryCharge", " " + deliveryCharge);
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        ToastUtils.showSnackBar(this, llMainLayout, "Delivery Charge has been added", "success");
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);

                 /*   cartGratuity = (float) o;
                    new UpdateOrderAsyncTask(() -> {
                        fetchOffline(false);
                        ToastUtils.showSnackBar(this, llMainLayout, "Gratuity has been added", "success");
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);*/
                }
            });

           /* order.order_status_id = "5";
            order.order_status = "Order Completed";
            new UpdateOrderAsyncTask(() -> {
                onBackPressed();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);*/
        }
        ivOrderOptions.performClick();

    }

    private void freeOldTable(String oldTableId) {
        LogUtils.e("TABLE::Freeing old table start");
        new Thread(() -> {
            Table table = appDatabase.tableDao().view(oldTableId);
            table.locked = false;
            table.table_status_id = vacantStatus.id;
            table.status = vacantStatus.status;
            table.last_order_id = null;
            table._last_order_id = 0;
            table.last_order_created_at = null;
            appDatabase.tableDao().insert(table);
            AndroidNetworking.post(ApiEndPoints.tables + table.id)
                    .addApplicationJsonBody(table)
                    .build()
                    .getAsObject(Table.class, new ParsedRequestListener() {
                        @Override
                        public void onResponse(Object response) {
                            LogUtils.e("TABLE FREEING STATUS CHANGED BEFORE RESPONSE:" + new Gson().toJson(table));
                        }

                        @Override
                        public void onError(ANError anError) {
                            if (anError.getErrorCode() == 400) {
                                LogUtils.e("TABLE FREEING OLD TABLE ERROR IN TABLE STATUS CHANGE: ", anError.getErrorAsObject(ApiError.class).getMessage());
                            }
                        }
                    });
        }).start();
    }

    private void changeTableStatusToFree(String table_id) {
        if (!order.order_type_id.equals("1")) {
            return;
        }
        LogUtils.e("TABLE order status while changing: " + order.order_status);
        new Thread(() -> {
            Table table = appDatabase.tableDao().view(table_id);
            if (table == null) return;
            table.table_status = appDatabase.tableStatusDao().view(table.table_status_id);
            if (table.table_status != null)
                table.status = table.table_status.status;
            else table.status = "";
            table.status = vacantStatus.status;
            table.table_status_id = vacantStatus.id;
            table.last_order_id = null;
            table._last_order_id = 0;
            table.last_order_created_at = null;
            table.locked = false;

            LogUtils.e("Table Updating ?:" + " number:" + table.number + " & ID:" + table.id + " & status:" + table.status + " &statusId:" + table.table_status_id);
            appDatabase.tableDao().insert(table);
            AndroidNetworking.post(ApiEndPoints.tables + table.id)
                    .addApplicationJsonBody(table)
                    .build()
                    .getAsObject(Table.class, new ParsedRequestListener() {
                        @Override
                        public void onResponse(Object response) {
                            LogUtils.e("TABLE STATUS CHANGED RESPONSE RECEIVED");
                        }

                        @Override
                        public void onError(ANError anError) {
                            if (anError.getErrorCode() == 400) {
                                LogUtils.e("ERROR IN TABLE STATUS CHANGE: ", anError.getErrorAsObject(ApiError.class).getMessage());
                            }
                        }
                    });
        }).start();
    }

    private void changeTableStatus(Order order, String table_status_id, String status) {
        if (!order.order_type_id.equals("1")) {
            return;
        }
        LogUtils.e("TABLE order status while changing: " + order.order_status);
        new Thread(() -> {
            Table table = appDatabase.tableDao().view(order.table_id);
            if (table == null) return;
            table.table_status = appDatabase.tableStatusDao().view(table.table_status_id);
            if (table.table_status != null)
                table.status = table.table_status.status;
            else table.status = "";

            String oldStatus = table.status;
            if (order.total > 0) {
                if (order.total_paid > 0) {
                    if (!order.order_status_id.equalsIgnoreCase("5") && !order.order_status_id.equalsIgnoreCase("10")) {
                        if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1) {
                            table.status = servedPaidStatus.status;
                            table.table_status_id = servedPaidStatus.id;
                        }
                    } else {
                        table.status = vacantStatus.status;
                        table.table_status_id = vacantStatus.id;
                        table.locked = false;
                    }
                } else {
                    if (!order.order_status_id.equalsIgnoreCase("5") &&
                            !order.order_status_id.equalsIgnoreCase("10")) {
                        if (order.order_status_id.equalsIgnoreCase("3")) {
                            table.status = servedStatus.status;
                            table.table_status_id = servedStatus.id;
                        } else {
                            if (Validators.isNullOrEmpty(order.order_action_id)) {
                                table.table_status_id = takingOrderStatus.id;
                                table.status = takingOrderStatus.status;
                            } else {
                                table.table_status_id = orderTakenStatus.id;
                                table.status = orderTakenStatus.status;
                            }
                        }
                    } else {
                        table.status = vacantStatus.status;
                        table.table_status_id = vacantStatus.id;
                        table.locked = false;
                    }
                }

            } else {
                if (!order.order_status_id.equalsIgnoreCase("5") && !order.order_status_id.equalsIgnoreCase("10")) {
                    table.status = takingOrderStatus.status;
                    table.table_status_id = takingOrderStatus.id;
                } else {
                    table.status = vacantStatus.status;
                    table.table_status_id = vacantStatus.id;
                    table.locked = false;
                }
            }

            LogUtils.e("Table Updating ?:" + " number:" + table.number + " & ID:" + table.id + " & status:" + table.status + " &statusId:" + table.table_status_id);
            appDatabase.tableDao().insert(table);
            AndroidNetworking.post(ApiEndPoints.tables + table.id)
                    .addApplicationJsonBody(table)
                    .build()
                    .getAsObject(Table.class, new ParsedRequestListener() {
                        @Override
                        public void onResponse(Object response) {
                            LogUtils.e("TABLE STATUS CHANGED RESPONSE RECEIVED");
                        }

                        @Override
                        public void onError(ANError anError) {
                            if (anError.getErrorCode() == 400) {
                                LogUtils.e("ERROR IN TABLE STATUS CHANGE: ", anError.getErrorAsObject(ApiError.class).getMessage());
                            }
                        }
                    });
        }).start();
    }

    private void lockTable(Order order, Table tableParam, boolean locked) {
        if (!order.order_type_id.equals("1")) {
            return;
        }

        new Thread(() -> {
            Table table = tableParam;
            if (table == null) {
                LogUtils.e("TABLE PARAM NULL");
                table = appDatabase.tableDao().view(order.table_id);
            } else {
                table = appDatabase.tableDao().view(tableParam.id);
            }
            LogUtils.e("Table Locking ?:" + locked + " number:" + table.number + " & ID:" + table.id + " & status:" + table.status);
            table.locked = locked;
            appDatabase.tableDao().insert(table);
            AndroidNetworking.post(ApiEndPoints.tables + table.id)
                    .addApplicationJsonBody(table)
                    .build()
                    .getAsObject(Table.class, new ParsedRequestListener() {
                        @Override
                        public void onResponse(Object response) {

                        }

                        @Override
                        public void onError(ANError anError) {
                            anError.printStackTrace();
                            if (anError.getErrorCode() == 400) {
                                LogUtils.e("TABLE::", anError.getErrorAsObject(ApiError.class).getMessage());
                            }
                        }
                    });
        }).start();
    }

    private void fetchDeliveryCharge(Callable<Void> nextThing) {
        if (!myApp.isConnected(this)) {
            if (nextThing != null) {
                try {
                    nextThing.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            return;
        }
        runOnUiThread(() -> {
            progressBarDialog.show();
        });
        AndroidNetworking.post(ApiEndPoints.calculate_delivery_charge)
                .addBodyParameter("distance", order.customer.distance)
                .build()
                .getAsObject(DeliveryCharge.class, new ParsedRequestListener<DeliveryCharge>() {
                    @Override
                    public void onResponse(DeliveryCharge response) {
                        runOnUiThread(() -> {
                            progressBarDialog.dismiss();
                        });
                        deliveryCharge = response.charge;
                        Log.e("Distance", "" + deliveryCharge);
                        if (nextThing != null) {
                            try {
                                nextThing.call();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    }

                    @Override
                    public void onError(ANError anError) {
                        runOnUiThread(() -> {
                            progressBarDialog.dismiss();
                        });
                        if (nextThing != null) {
                            try {
                                nextThing.call();
                            } catch (Exception e) {
                                e.printStackTrace();
                            }
                        }
                    }
                });
    }

    private void fetchDeliveryChargeOffline(Callable<Void> nextThing) {
        if (!myApp.isConnected(this)) {
            if (nextThing != null) {
                try {
                    nextThing.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            OrderWithItems orderWithItems_temp = myApp.appDatabase.orderDao().orderWithItems(_order_id);
            if (orderWithItems_temp != null) {
                Order order_temp = orderWithItems_temp.order;

                shouldFetchDeliveryCharge = order.order_type_id.equalsIgnoreCase("3");
                if (shouldFetchDeliveryCharge) {
                    deliveryCharge = order.delivery_charge;
                }
            }
            return;
        }
        runOnUiThread(() -> {
            progressBarDialog.show();
        });
        Log.e("Distance", "" + order.customer.distance);

    }

    private void editProduct(int position, String action, Object data) {
        if ((!Validators.isNullOrEmpty(order.split_type) && order.split_type.equalsIgnoreCase("person")) && (MyApp.userPermission != null && MyApp.userPermission.modify.actions.list) && !canEditOrder) {
            return;
        }
        OrderItem orderItem = (OrderItem) data;
        if (action != null && !action.equalsIgnoreCase("view")) {
            ArrayList<OrderItem> orderItems = new ArrayList<>();
            orderItems.add(orderItem);
            new AddOrUpdateOrderSideItemAsyncTask(() -> {
                new UpdateOrderAsyncTask(() -> {
                    fetchOffline(false);
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, orderItems);
        } else {
            if (selectedSplit == null || (orderItem._order_split_id == selectedSplit._id && selectedSplit.paid_amount == 0)) {
                CartProductEditDialogFragment cartProductEditDialogFragment = CartProductEditDialogFragment.getInstance(order.order_type_id, orderItem);
                cartProductEditDialogFragment.show(getSupportFragmentManager(), "product_view");
                cartProductEditDialogFragment.setDialogDismissListener((o) -> {
                });
            } else {
                ToastUtils.showSnackBar(NewOrderActivity.this, llMainLayout, "Cannot change in paid split group", "failed");
            }

        }

    }

    private void setCartValues() {
        new Thread(() -> {
            cartSubTotal = order.sub_total;
            cartDiscount = order.discount;
            cartGratuity = order.gratuity;
            cartGrandTotal = ((cartSubTotal + cartGratuity + cartServiceCharge + order.delivery_charge) - cartDiscount);
            cartServiceCharge = order.service_charge;
            runOnUiThread(() -> {
                tvSubtotal.setText(MyApp.currencySymbol + MyApp.df.format(cartSubTotal));
                tvGrandTotal.setText(MyApp.currencySymbol + MyApp.df.format(cartGrandTotal));

                if (cartDiscount > 0) {
                    llDiscount.setVisibility(View.VISIBLE);
                    tvDiscount.setText(MyApp.currencySymbol + MyApp.df.format(cartDiscount));
                    if (autoDiscountApplied) {
                        tvDiscountText.setCompoundDrawablesWithIntrinsicBounds(0, 0, 0, 0);
                        tvDiscountText.setClickable(false);
                    } else {
                        tvDiscountText.setClickable(true);
                        tvDiscountText.setCompoundDrawablesWithIntrinsicBounds(R.drawable.ic_baseline_green_close_18, 0, 0, 0);
                    }
                } else {
                    llDiscount.setVisibility(View.GONE);
                }
                if (cartGratuity > 0) {
                    llGratuity.setVisibility(View.VISIBLE);
                    tvGratuity.setText(MyApp.currencySymbol + MyApp.df.format(cartGratuity));
                    tvGratuityText.setCompoundDrawablesWithIntrinsicBounds(R.drawable.ic_baseline_green_close_18, 0, 0, 0);
                } else {
                    llGratuity.setVisibility(View.GONE);
                }
                if (cartServiceCharge > 0) {
                    llServiceCharge.setVisibility(View.VISIBLE);
                    tvServiceCharge.setText(MyApp.currencySymbol + MyApp.df.format(cartServiceCharge));
                    if (serviceChargeAutoMode) {
                        tvServiceChargeText.setCompoundDrawablesWithIntrinsicBounds(0, 0, 0, 0);
                        tvServiceChargeText.setClickable(false);
                     /*   tvServiceChargeText.setClickable(true);
                        tvServiceChargeText.setCompoundDrawablesWithIntrinsicBounds(R.drawable.ic_baseline_green_close_18, 0, 0, 0);*/
                    } else {
                        tvServiceChargeText.setClickable(true);
                        tvServiceChargeText.setCompoundDrawablesWithIntrinsicBounds(R.drawable.ic_baseline_green_close_18, 0, 0, 0);
                    }
                } else {
                    llServiceCharge.setVisibility(View.GONE);
                }
                if (order.delivery_charge > 0) {
                    Log.e("order.deliverycharge", "" + order.delivery_charge);
                    llDelivery.setVisibility(View.VISIBLE);
                    tvDelivery.setText(MyApp.currencySymbol + MyApp.df.format(order.delivery_charge));

                    if (deliveryChargeTypeOption.value.equals("manual")) {
                        Log.e("order.deliverycharge", "" + deliveryChargeTypeOption);
                        tvDeliveryText.setCompoundDrawablesWithIntrinsicBounds(R.drawable.ic_baseline_green_close_18, 0, 0, 0);
                    }

                    String customer_address = order.customer.house_no + " ," + order.customer.street + " ," + order.customer.country;
                    tvcustomer_detail.setText("" + customer_address);

                    String customer_contact = order.customer.name + " (" + order.customer.mobile + ")";
                    tvcustomer_contact.setText("" + customer_contact);

                    llCustomerInfo.setVisibility(View.VISIBLE);
                } else {
                    llDelivery.setVisibility(View.GONE);
                    llCustomerInfo.setVisibility(View.GONE);
                }
            });
        }).start();
    }

    private void fetchOffline(boolean redirect) {
        new FetchOrderOfflineAsyncTask(() -> {
            LogUtils.e("ORDER::", "AFTER FETCH ORDER: SBUTOTAL::", "cartSubTotal::" + cartSubTotal, "order.sub_total" + order.sub_total, "cartGrandTotal::" + cartGrandTotal, "cartGrandTotal::" + order.total);
            orderItemsAdapter.notifyDataSetChanged();
            progressBarDialog.dismiss();
            updateViews();
            if (redirect) {
                lockTable(order, null, true);
                if (!Validators.isNullOrEmpty(destination)) {
                    if (destination.equalsIgnoreCase("pay_bill")) {
                        openPayBillScreen();
                    }
                }
            }
            return null;
        }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
    }

    private void openPayBillScreen() {
        if (!Validators.isNullOrEmpty(order.split_type) && shouldOpenSplitScreen) {
            startActivityForResult(new Intent(NewOrderActivity.this, SplitActivity.class).putExtra("_order_id", order._id).putExtra("order_id", order.id), Constants.CODE_REFRESH);
        } else
            startActivityForResult(new Intent(NewOrderActivity.this, OrderReviewActivity.class).putExtra("order_id", order.id).putExtra("_order_id", order._id).putExtra("order_total", order.total).putExtra("paid_amount", order.total_paid), Constants.CODE_REFRESH);
    }

    private void changeFragment(Fragment fragment, boolean enableBackPress) {
        if (getIntent() != null) {
            if (fragment.getArguments() != null) {
                fragment.getArguments().putAll(getIntent().getExtras());
            } else {
                fragment.setArguments(getIntent().getExtras());
            }
        }
        if (fragment instanceof ProductAreaFragment) {
            llSearch.setVisibility(View.VISIBLE);
        } else {
            llSearch.setVisibility(View.INVISIBLE);
        }
        FragmentManager manager = getSupportFragmentManager();
        FragmentTransaction transaction = manager.beginTransaction();
        transaction.replace(R.id.flProductArea, fragment);
        if (enableBackPress) {
            transaction.addToBackStack("can_go_back");
        }
        transaction.commit();
    }

    private boolean isValidToPlaceOrder() {
        if (!Validators.isNullOrEmpty(order.split_type) && order.split_type.equalsIgnoreCase("person")) {
            return false;
        }
        // Order completed
        return !order.order_status_id.equalsIgnoreCase("5");
    }

    private void changeStatusCallerid(String status) {
        callLogs.status = status;
        cvCallerId.setVisibility(View.GONE);
        if (callLogs.status.equalsIgnoreCase("accepted")) {
            OrderTypeSelectionDialogFragment orderTypeSelectionDialog = OrderTypeSelectionDialogFragment.getInstance(callLogs);
            orderTypeSelectionDialog.show(getSupportFragmentManager(), "order_type");
            orderTypeSelectionDialog.setDialogDismissListener(o -> {
                if (o instanceof String) {
                    String orderTypeId = (String) o;
                    NewOrderDialogFragment newOrderDialogFragment = NewOrderDialogFragment.getInstance(callLogs, orderTypeId);
                    newOrderDialogFragment.show(getSupportFragmentManager(), "new_order");
                    newOrderDialogFragment.setDialogDismissListener(o1 -> {
                        if (o1 instanceof Order) {
                            uploadOrder();
                            finish();
                            startActivity(new Intent(this, NewOrderActivity.class).putExtra("order", new Gson().toJson(o1)).putExtra("fetch_delivery_charge", ((Order) o1).order_type_id.equalsIgnoreCase("3")));
                        } else if (o1 instanceof CallLogs) {
                            createNewReservation((CallLogs) o1);
                        }

                    });
                } else if (o instanceof CallLogs) {
                    createNewReservation((CallLogs) o);
                }
            });

        }
        new Thread(() -> {
            callLogs.uploadable = true;
            appDatabase.calllogDao().insert(callLogs);
        }).start();
    }

    private void createNewReservation(CallLogs o) {
        uploadOrder();
        startActivity(new Intent(this, HomeActivity.class).putExtra("destination", "reservations").putExtra("calllogs", new Gson().toJson(o)));
        finish();
    }

    @Override
    public void onBackPressed() {
        setResult(RESULT_OK);
        Fragment openedFragment = getSupportFragmentManager().findFragmentById(R.id.flProductArea);
        if (openedFragment instanceof ProductAreaFragment) {
            uploadOrder();
            finish();
        } else {
            llSearch.setVisibility(View.VISIBLE);
            if (manager.getBackStackEntryCount() > 0) {
                manager.popBackStack();
            }
        }
    }

    private void uploadOrder() {
        if (callChangeTableStatus) {
            LogUtils.e("TABLE upload order");
            changeTableStatus(order, orderTakenStatus.id, "Order Taken");
        }
        if (needToUpload) {
            Intent intent = new Intent(this, SingleOrderUploaderService.class);
            intent.putExtra("_order_id", _order_id);
            startService(intent);
        }
    }

    @Override
    protected void onStop() {
        super.onStop();
        LogUtils.e("On Stop");
    }

    @Override
    public void onDestroy() {
        LogUtils.e("On Destroy");
        if (progressBarDialog != null) progressBarDialog.dismiss();

        if (printAction && defaultPrinter != null && (defaultPrinter.printer_model_name.toLowerCase().contains("pos-80") || defaultPrinter.printer_model_name.toLowerCase().contains("pos 80") || defaultPrinter.printer_model_name.toLowerCase().contains("yoke4"))) {
            wifiPrinter.disconnect();
        }
        if (orderItemReceiver != null)
            LocalBroadcastManager.getInstance(NewOrderActivity.this).unregisterReceiver(orderItemReceiver);
        if (orderButtonClickReceiver != null)
            LocalBroadcastManager.getInstance(NewOrderActivity.this).unregisterReceiver(orderButtonClickReceiver);


        calllogViewModel.getCallLogs().removeObservers(this);
        super.onDestroy();
    }

    @Override
    protected void onResume() {
        super.onResume();
        LocalBroadcastManager.getInstance(this).registerReceiver(callReceiver, new IntentFilter("call_received"));
        LocalBroadcastManager.getInstance(this).registerReceiver(orderUpdateReceiver, new IntentFilter(Constants.EPOS_ORDER_UPDATE));
    }

    @Override
    protected void onPause() {
        super.onPause();
        if (callReceiver != null && callReceiver.isOrderedBroadcast()) {
            LocalBroadcastManager.getInstance(this).unregisterReceiver(callReceiver);
        }
        if (orderUpdateReceiver != null) {
            LocalBroadcastManager.getInstance(this).unregisterReceiver(orderUpdateReceiver);
        }
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == Constants.CODE_REFRESH && resultCode == RESULT_OK) {
            LogUtils.e("TABLE OnActivityResult");
            new FetchOrderOfflineAsyncTask(() -> {
                LogUtils.e("TABLE:::TOTAL::" + order.total + " & PAID::" + order.total_paid);
                printableTotal = order.total;
                orderItemsAdapter.notifyDataSetChanged();
                progressBarDialog.dismiss();
                updateViews();
                int print_count = 0;
                String order_action = null;
                int _split_id = 0;
                if (data != null) {
                    print_count = data.getIntExtra("print_count", 0);
                    _split_id = data.getIntExtra("_order_split_id", 0);
                    order_action = data.getStringExtra("order_action");
                }
                LogUtils.e("OnActivityResult SPLIT ID::" + _split_id);
                splitByPersonPrint = false;
                LogUtils.e("OnActivityResult need to print? " + myApp.needToPrint);
                if (myApp.needToPrint) {
                    myApp.needToPrint = false;
                    if (print_count > 0) {
                        splitByPersonPrint = true;
                        printableTotal = printableTotal / print_count;
                        for (int i = 0; i < print_count; i++) {
                            createPrint("", false, print_count == i + 1, false);
                        }
                    } else if (_split_id > 0) {
                        createSplitPrint(_split_id);
                    } else if (!Validators.isNullOrEmpty(order_action)) {
                        if (order_action.equalsIgnoreCase("full_order")) {
                            createPrint("Full Order", true, true, false);
                        } else if (order_action.equalsIgnoreCase("duplicate_order")) {
                            createPrint("Duplicate Order", true, true, false);
                        } else if (order_action.equalsIgnoreCase("updated_order")) {
                            createPrint("Updated Order", true, true, false);
                        } else if (order_action.equalsIgnoreCase("duplicate_updated_order")) {
                            createPrint("Duplicate Updated Order", true, true, false);
                        } else if (order_action.equalsIgnoreCase("print_all")) {
                            createBillPrint("", true, false, false);
                            createBillPrint("", false, true, false);

//                            createBillPrint("Full Order", false, false, false);

                        } else if (order_action.equalsIgnoreCase("print_bill")) {
                            createBillPrint("print_bill", false, true, false);
                        } else {
                            onBackPressed();
                        }
                    } else {
                        afterPaymentPrintOptions();
                    }

                } else {
                    LogUtils.e("TABLE OnActivityResult: No Print");
                }
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        }
    }

    private void afterPaymentPrintOptions() {
        if (payBillActionModeSetting != null && payBillActionModeSetting.value.equalsIgnoreCase("auto")) {

            if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("both")) {
                createPrint("", true, false, false);
                createPrint("", false, true, false);
            } else if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("bill")) {
                createPrint("", false, true, false);
            } else if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                createPrint("", true, true, false);
            } else {
                onBackPressed();
            }

        } else {

            if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("both")) {
                askForPrintLocation(true);
            } else if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("bill")) {
                askForPrintLocation(true);
            } else if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                askForPrintLocation(false);
            } else {
                onBackPressed();
            }

        }
    }

    private void askForPrintLocation(boolean billPrint) {
        String messge = "Do you want to print bill receipt?";
        if (!billPrint) {
            messge = "Do you want prep ticket?";
        }
        ConfirmationDialogFragment confirmationDialogFragment = ConfirmationDialogFragment.getInstance("Print", messge, 0, "Confirm", "Cancel");
        confirmationDialogFragment.setCancelable(false);
        confirmationDialogFragment.show(getSupportFragmentManager(), "action");
        confirmationDialogFragment.setDialogDismissListener(o -> {
            if (o instanceof String) {
                if (((String) o).equalsIgnoreCase("confirm")) {
                    if (billPrint) {
                        createPrint("", false, false, false);
                        if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                            askForPrintLocation(false);
                        } else {
                            if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
                                onBackPressed();
                        }
                    } else
                        createPrint("", true, true, false);
                } else {
                    if (billPrint) {
                        if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                            askForPrintLocation(false);
                        } else {
                            if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
                                onBackPressed();
                        }
                    } else {
                        if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
                            onBackPressed();
                    }
                }
            } else {
                if (billPrint) {
                    if (payBillActionSetting != null && payBillActionSetting.value.equalsIgnoreCase("prep_ticket")) {
                        askForPrintLocation(false);
                    } else {
                        if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
                            onBackPressed();
                    }
                } else {
                    if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
                        onBackPressed();
                }
            }
        });
    }

    private boolean showSendOrderButton() {
        if (sendOrderMainSetting == null && sendOrderUpdateMainSetting == null && sendDupOrderMainSetting == null && sendDupOrderUpdateMainSetting == null) {
            return false;
        }
        return (sendOrderMainSetting == null || (!sendOrderMainSetting.value.equalsIgnoreCase("false") && !sendOrderMainSetting.value.equalsIgnoreCase("0"))) || (sendOrderUpdateMainSetting == null || (!sendOrderUpdateMainSetting.value.equalsIgnoreCase("false") && !sendOrderUpdateMainSetting.value.equalsIgnoreCase("0"))) || (sendDupOrderMainSetting == null || (!sendDupOrderMainSetting.value.equalsIgnoreCase("false") && !sendDupOrderMainSetting.value.equalsIgnoreCase("0"))) || (sendDupOrderUpdateMainSetting == null || (!sendDupOrderUpdateMainSetting.value.equalsIgnoreCase("false") && !sendDupOrderUpdateMainSetting.value.equalsIgnoreCase("0")));
    }

    private void createBillPrint(String title, boolean kitchenCopy, boolean goBack, boolean updateOrder) {
        if (defaultPrinter != null && defaultPrinter.printer_model_name != null) {
            if (kitchenCopy) {
                new PrepLocationSenderAsync(title, updateOrder, () -> {
                    if (goBack)
                        onBackPressed();
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            } else {
                new OrderItemsPrintBlockAsync(null, () -> {
                    LogUtils.e("TABLE Can we go back? " + (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1 || !Validators.isNullOrEmpty(title)) + " OrderTotal:" + order.total + " Paid: " + order.total_paid + " Title is nullorempty?" + Validators.isNullOrEmpty(title));
                    if (goBack) {
                        onBackPressed();
                    }
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            }
        } else {
            LogUtils.e("TABLE Can we go if no printer back? " + (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1 || !Validators.isNullOrEmpty(title)) + " OrderTotal:" + order.total + " Paid: " + order.total_paid + " Title is nullorempty?" + Validators.isNullOrEmpty(title));
            ToastUtils.makeLongToast(this, "No printer model found");
            if (goBack) {
                onBackPressed();
            }
        }
    }

    private void createPrint(String title, boolean kitchenCopy, boolean goBack, boolean updateOrder) {
        if (defaultPrinter != null && defaultPrinter.printer_model_name != null) {
            if (kitchenCopy) {
                new PrepLocationSenderAsync(title, updateOrder, () -> {
                    if (goBack && (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1 || !Validators.isNullOrEmpty(title)))
                        onBackPressed();
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            } else {
                new OrderItemsPrintBlockAsync(null, () -> {
                    LogUtils.e("TABLE Can we go back? " + (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1 || !Validators.isNullOrEmpty(title)) + " OrderTotal:" + order.total + " Paid: " + order.total_paid + " Title is nullorempty?" + Validators.isNullOrEmpty(title));
                    if (goBack && (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1 || !Validators.isNullOrEmpty(title))) {
                        onBackPressed();
                    }
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            }
        } else {
            LogUtils.e("TABLE Can we go if no printer back? " + (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1 || !Validators.isNullOrEmpty(title)) + " OrderTotal:" + order.total + " Paid: " + order.total_paid + " Title is nullorempty?" + Validators.isNullOrEmpty(title));
            ToastUtils.makeLongToast(this, "No printer model found");
            if (goBack && (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1 || !Validators.isNullOrEmpty(title))) {
                onBackPressed();
            }
        }
    }

    private void createSplitPrint(int _split_id) {
        if (defaultPrinter != null && defaultPrinter.printer_model_name != null) {
            new OrderItemsPrintBlockAsync(null, () -> {
                if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
                    onBackPressed();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, _split_id);
        } else {
            ToastUtils.makeLongToast(this, "No printer model found");
            if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1)
                onBackPressed();
        }

    }

    private void searchPostcode(String postcode) {
        Postcode searchedPostcode = new Postcode();
        if (!myApp.isConnected(getApplicationContext())) {
            ToastUtils.makeSnackToast(getApplicationContext(), "No internet connection");
            return;
        }
        AndroidNetworking.get(ApiEndPoints.postcode + postcode)
                .build()
                .getAsObject(Postcode.class, new ParsedRequestListener<Postcode>() {
                    @Override
                    public void onResponse(Postcode response) {
                        calculateDistance(searchedPostcode.latitude, searchedPostcode.longitude);
                    }

                    @Override
                    public void onError(ANError anError) {
                        progressBarDialog.dismiss();
                        if (anError.getErrorCode() == 400) {
                            ApiError apiError = anError.getErrorAsObject(ApiError.class);
                            ToastUtils.makeSnackToast(getApplicationContext(), apiError.getMessage());
                        }
                        if (!myApp.isConnected(getApplicationContext())) {
                            ToastUtils.makeSnackToast(getApplicationContext(), "No internet connection");
                        }
                    }
                });
    }

    private void calculateDistance(String latitude, String longitude) {
        SiteSetting findLongitude = myApp.findSetting("address_longitude");
        SiteSetting findlatitude = myApp.findSetting("address_latitude");

        if (findLongitude != null && findlatitude != null) {
            if (!Validators.isNullOrEmpty(findlatitude.value) &&
                    !Validators.isNullOrEmpty(findLongitude.value) &&
                    !Validators.isNullOrEmpty(latitude) && !Validators.isNullOrEmpty(longitude)) {
                Location locationRestaurant = new Location("Restaurant Location");
                locationRestaurant.setLongitude(Double.parseDouble(findLongitude.value));
                locationRestaurant.setLatitude(Double.parseDouble(findlatitude.value));

                Location locationUser = new Location("User Location");
                locationUser.setLongitude(Double.parseDouble(longitude));
                locationUser.setLatitude(Double.parseDouble(latitude));

                float d = locationRestaurant.distanceTo(locationUser) * 0.000621371f;
                float distance = Float.parseFloat(MyApp.df.format(d));
                Log.e("distance", "" + distance);
            }
        }
    }

    private class AddOrUpdateOrderSideItemAsyncTask extends AsyncTask<Object, Object, Object> {
        Callable<Void> nextMethod;

        public AddOrUpdateOrderSideItemAsyncTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected Object doInBackground(Object... objects) {
            if (objects[0] instanceof List) {
                ArrayList<OrderItem> orderItems = (ArrayList<OrderItem>) objects[0];
                for (OrderItem orderItem : orderItems) {
                    OrderItem dbOrderItem = appDatabase.orderItemDao().view(orderItem._id);

                    if (orderItem._order_split_id > 0) {
                        OrderSplit dbSplit = null;
                        if (orderItem._order_split_id == selectedSplit._id) {
                            dbSplit = selectedSplit;
                        } else {
                            dbSplit = appDatabase.orderSplitDao().view(orderItem._order_split_id);
                        }
                        if (dbSplit.paid_amount > 0) {
                            ToastUtils.showSnackBar(NewOrderActivity.this, llMainLayout, "Cannot change in paid split group", "failed");
                            break;
                        }
                    }
                    int dbOrderItemId, quantity;
                    if (orderItem.quantity <= 0) {
                        if (dbOrderItem != null) {
                            appDatabase.orderItemDao().delete(dbOrderItem);
                            if (orderItem._order_split_id > 0) {
                                appDatabase.orderSplitDao().updateTotalAmount(orderItem._order_id, orderItem._order_split_id);
                            }
                            continue;
                        }
                    }
                    if (dbOrderItem != null) {
                        dbOrderItem.quantity = orderItem.quantity;
                        quantity = dbOrderItem.quantity;
                        dbOrderItem.sub_total = dbOrderItem.quantity * orderItem.price;
                        dbOrderItem.instruction_price = orderItem.instruction_price;
                        dbOrderItem.special_instruction = orderItem.special_instruction;
                        dbOrderItem.total = dbOrderItem.sub_total + dbOrderItem.addons_price + dbOrderItem.ingredients_price + (dbOrderItem.instruction_price * dbOrderItem.quantity);
                        myApp.appDatabase.orderItemDao().update(dbOrderItem);
                        dbOrderItemId = dbOrderItem._id;
                    } else {
                        quantity = orderItem.quantity;
                        orderItem.order_id = order.id;
                        orderItem._order_id = order._id;
                        orderItem.sub_total = orderItem.quantity * orderItem.price;
                        orderItem.total = orderItem.sub_total + orderItem.addons_price + orderItem.ingredients_price + (orderItem.instruction_price * orderItem.quantity);
                        dbOrderItemId = (int) myApp.appDatabase.orderItemDao().insert(orderItem);
                    }
                    float addonTotal = 0;
                    if (orderItem.order_item_addons != null) {
                        for (OrderItemAddon itemAddon : orderItem.order_item_addons) {
                            itemAddon._order_item_id = dbOrderItemId;
                            itemAddon.total = itemAddon.quantity * itemAddon.price;
                            addonTotal = addonTotal + itemAddon.total;
                        }
                        myApp.appDatabase.orderItemAddonDao().insertAll(orderItem.order_item_addons);
                    }

                    float ingredientTotal = 0;
                    if (orderItem.order_item_ingredients != null) {
                        appDatabase.orderItemIngredientDao().deleteAll(dbOrderItemId);
                        for (OrderItemIngredient itemIngredient : orderItem.order_item_ingredients) {
                            itemIngredient._order_item_id = dbOrderItemId;
                            itemIngredient.total = itemIngredient.quantity * itemIngredient.price;
                            ingredientTotal = ingredientTotal + itemIngredient.total;
                        }
                        appDatabase.orderItemIngredientDao().insertAll(orderItem.order_item_ingredients);
                    }

                    ingredientTotal = ingredientTotal * quantity;
                    addonTotal = addonTotal * quantity;
                    myApp.appDatabase.orderItemDao().updateOrderItemTotal(dbOrderItemId, addonTotal, ingredientTotal);
                    if (orderItem._order_split_id > 0) {
                        appDatabase.orderSplitDao().updateTotalAmount(orderItem._order_id, orderItem._order_split_id);
                    }
                }
                Order dbOrder = appDatabase.orderDao().view(order._id);
                dbOrder.sub_total = myApp.appDatabase.orderDao().getItemSubTotal(order._id);
                dbOrder.updated_at = CommonFunctions.convertMsToDesiredFormat(System.currentTimeMillis(), Constants.PHP_DATE_TIME_FORMAT_ZULU);
                appDatabase.orderDao().update(dbOrder);

            }
            return null;
        }

        @Override
        protected void onPostExecute(Object s) {
            super.onPostExecute(s);
            if (nextMethod != null) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private class UpdateOrderStatusAsyncTask extends AsyncTask<Object, Object, Object> {
        Callable<Void> nextMethod;


        public UpdateOrderStatusAsyncTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected Object doInBackground(Object... objects) {

            if (orderCompleteAuto && CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1) {
                order.order_status_id = "5";
                order.order_status = "Order Completed";
            }

            appDatabase.orderDao().update(order);

            if (order.order_type_id.equalsIgnoreCase("1") && !Validators.isNullOrEmpty(order.table_id) &&
                    (order.order_status_id.equalsIgnoreCase("5") ||
                            order.order_status_id.equalsIgnoreCase("10"))) {
                Table table = appDatabase.tableDao().view(order.table_id);
                table.status = vacantStatus.status;
                table.locked = false;
                table.last_order_total = 0;
                table.last_order_id = null;
                table._last_order_id = 0;
                table.last_order_created_at = null;
                table.table_status_id = vacantStatus.id;
                appDatabase.tableDao().insert(table);
            }
            return null;
        }

        @Override
        protected void onPostExecute(Object s) {
            super.onPostExecute(s);
            if (nextMethod != null) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private class UpdateOrderAsyncTask extends AsyncTask<Object, Object, Object> {
        Callable<Void> nextMethod;


        public UpdateOrderAsyncTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected Object doInBackground(Object... objects) {
            order.sub_total = myApp.appDatabase.orderDao().getItemSubTotal(order._id);
            LogUtils.e("ORDER::", "Order Sub Total::" + order.sub_total);
            cartSubTotal = order.sub_total;
            LogUtils.e("ORDER::", "Cart Sub Total::" + cartSubTotal);

            if (serviceChargeEnabled) {
                if (serviceChargeAutoMode) {
                    float serviceChargeValue = Float.parseFloat(serviceChargeSetting.value);
                    if (serviceChargeTypeSetting.value.equalsIgnoreCase("flat")) {
                        cartServiceCharge = serviceChargeValue;
                    } else {
                        if (serviceChargeValue > 0) {
                            cartServiceCharge = cartSubTotal * serviceChargeValue / 100;
                        } else {
                            cartServiceCharge = 0;
                        }
                    }
                }
            }

            if (discountEnabled) {
                List<Discount> discounts = appDatabase.discountDao().eligibleDiscounts("%" + myApp.current_day + "%", "%" + order.order_type_id + "%", order.sub_total, CommonFunctions.getCurrentTimeFormatted("yyyy-MM-dd"), CommonFunctions.getCurrentTimeFormatted("yyyy-MM-dd"));
                if (discounts.size() > 0) {
                    Discount appliedDiscount = discounts.get(0);
                    autoDiscountApplied = false;
                    if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("flat")) {
                        if (cartSubTotal > 0)
                            cartDiscount = appliedDiscount.discount;
                        else cartDiscount = 0;
                        autoDiscountApplied = true;
                    }
                    if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("percentage")) {
                        if (cartSubTotal > 0)
                            cartDiscount = cartSubTotal * appliedDiscount.discount / 100;
                        else cartDiscount = 0;
                        autoDiscountApplied = true;
                    }
                } else {
                    if (autoDiscountApplied) cartDiscount = 0;
                }
            }

            order.delivery_charge = deliveryCharge;
            order.gratuity = cartGratuity;
            order.discount = cartDiscount;
            order.service_charge = cartServiceCharge;
            cartGrandTotal = (cartSubTotal + cartGratuity + cartServiceCharge + order.delivery_charge) - cartDiscount;
            order.total = cartGrandTotal;

            if (!order.order_status_id.equalsIgnoreCase("5") && !order.order_status_id.equalsIgnoreCase("10")) {
                order.updated_at = CommonFunctions.convertMsToDesiredFormat(System.currentTimeMillis(), Constants.PHP_DATE_TIME_FORMAT_ZULU);
            }
            if (orderCompleteAuto && CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1) {
                order.order_status_id = "5";
                order.order_status = "Order Completed";
            }
            appDatabase.orderDao().update(order);

            if (order.order_type_id.equalsIgnoreCase("1") &&
                    !Validators.isNullOrEmpty(order.table_id) &&
                    (order.order_status_id.equalsIgnoreCase("5") ||
                            order.order_status_id.equalsIgnoreCase("10"))) {
                Table table = appDatabase.tableDao().view(order.table_id);
                table.status = vacantStatus.status;
                table.locked = false;
                table.last_order_total = 0;
                table.last_order_id = null;
                table._last_order_id = 0;
                table.last_order_created_at = null;
                table.table_status_id = vacantStatus.id;
                appDatabase.tableDao().insert(table);
            }
            return null;
        }

        @Override
        protected void onPostExecute(Object s) {
            super.onPostExecute(s);
            if (nextMethod != null) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private class FetchOrderOfflineAsyncTask extends AsyncTask<Object, Object, Object> {
        Callable<Void> nextMethod;

        public FetchOrderOfflineAsyncTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected Object doInBackground(Object... paramObjects) {
            orderWithItems = myApp.appDatabase.orderDao().orderWithItems(_order_id);
            if (orderWithItems != null) {
                order = orderWithItems.order;

                boolean splitException = false;
                if (order.split_type != null) {
                    try {
                        appDatabase.orderSplitDao().updatePaidAmount(_order_id);
                    } catch (Exception e) {
                        e.printStackTrace();
                        splitException = true;
                    }
                }
                order.total_paid = appDatabase.orderPaymentDao().getTotalPaidAmount(_order_id);
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("1")) {
                    order.order_type = "Dine in";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("2")) {
                    order.order_type = "Collection";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("3")) {
                    order.order_type = "Delivery";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("4")) {
                    order.order_type = "Bar";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("5")) {
                    order.order_type = "Waiting";
                }
                if (shouldFetchDeliveryCharge) {
                    order.delivery_charge = deliveryCharge;
                }

                Log.e("deliveryCharge", "" + deliveryCharge + " " + order.delivery_charge);

                if (serviceChargeVisible) {
                    SiteSetting services_charges = myApp.findSetting("service_charge_order_type");
                    if (services_charges != null) {
                        List<String> split_funcation = Links.split_funcation(services_charges.value);
                        for (int i = 0; i < split_funcation.size(); i++) {
                            if (order.order_type.equalsIgnoreCase(split_funcation.get(i))) {
                                serviceChargeEnabled = true;
                                break;
                            } else {
                                serviceChargeEnabled = false;
                            }
                        }
                    }
                }

                if (!Validators.isNullOrEmpty(order.table_id))
                    order.table_number = appDatabase.tableDao().view(order.table_id).number;

                order.order_payments = (ArrayList<OrderPayment>) orderWithItems.orderPayments;
                order.order_splits = (ArrayList<OrderSplit>) orderWithItems.orderSplits;
                if (splitException) {
                    for (OrderSplit orderSplit : order.order_splits) {
                        orderSplit.paid_amount = appDatabase.orderPaymentDao().getSplitTotalPaidAmount(_order_id, orderSplit._id);
                        appDatabase.orderSplitDao().update(orderSplit);
                    }
                }
                order.order_items = new ArrayList<>();
                orderItems.clear();
                HashMap<OrderSplit, List<OrderItem>> orderItemsWithSplitId = new HashMap<>();
                for (OrderItemWithAddonsIngredients item : orderWithItems.orderItems) {
                    OrderItem orderItem = item.orderItem;
                    orderItem.order_item_addons = (ArrayList<OrderItemAddon>) item.orderItemAddons;
                    orderItem.order_item_ingredients = (ArrayList<OrderItemIngredient>) item.orderItemIngredients;
                    order.order_items.add(orderItem);
                    if (orderItem._order_split_id == 0) {
                        orderItems.add(orderItem);
                    } else {
                        OrderSplit split = new OrderSplit();
                        split._id = orderItem._order_split_id;
                        List<OrderItem> splitOrderItems = new ArrayList<>();
                        if (selectedSplit != null && split._id == selectedSplit._id) {
                            if (orderItemsWithSplitId.containsKey(split)) {
                                splitOrderItems = orderItemsWithSplitId.get(split);
                            }
                            splitOrderItems.add(orderItem);
                        }
                        orderItemsWithSplitId.put(split, splitOrderItems);
                    }
                }

                Collections.reverse(orderItems);
                if (!Validators.isNullOrEmpty(order.split_type) && order.split_type.equalsIgnoreCase("order_item")) {
                    //We will show none splitted items first.
                    objects.clear();
                    objects.addAll(orderItems);

                    for (Map.Entry<OrderSplit, List<OrderItem>> entry : orderItemsWithSplitId.entrySet()) {

                        OrderSplit split = appDatabase.orderSplitDao().view(entry.getKey()._id);
                        if (selectedSplit != null && split._id == selectedSplit._id) {
                            split.selected = true;
                        }
                        LogUtils.e("ONREFRESH : SPLIT: " + new Gson().toJson(split));
                        objects.add(split);
                        objects.addAll(entry.getValue());
                    }
//                    for (OrderSplit split : order.order_splits) {
//                        ArrayList<OrderItem> splitItems = (ArrayList<OrderItem>) appDatabase.orderItemDao().listSplitItems(split._id);
//                        if (splitItems.size() == 0) continue;
//                        objects.add(split);
//                        for (OrderItem oit : splitItems) {
//                            oit.order_item_addons = (ArrayList<OrderItemAddon>) appDatabase.orderItemAddonDao().list(oit._id);
//                            oit.order_item_ingredients = (ArrayList<OrderItemIngredient>) appDatabase.orderItemIngredientDao().list(oit._id);
//                            objects.add(oit);
//                        }
//                    }
                } else {
                    objects.clear();
                    objects.addAll(orderItems);
                }

                order.customer = myApp.appDatabase.customerDao().view(order._customer_id);
                if (order.customer == null) {
                    order.customer = appDatabase.customerDao().view(order.customer_id);
                }
                if (order.service_charge == 0) {
                    Log.e("serviceChargeEnabled", " " + serviceChargeEnabled);
                    if (serviceChargeEnabled) {
                        if (serviceChargeAutoMode) {
                            float serviceChargeValue = Float.parseFloat(serviceChargeSetting.value);
                            if (serviceChargeTypeSetting.value.equalsIgnoreCase("flat")) {
                                cartServiceCharge = serviceChargeValue;
                            } else {
                                if (serviceChargeValue > 0) {
                                    cartServiceCharge = cartSubTotal * serviceChargeValue / 100;
                                } else {
                                    cartServiceCharge = 0;
                                }
                            }
                        }
                    } else {
                        cartServiceCharge = 0;
                    }
                } else {
                    cartServiceCharge = order.service_charge;
                }

                if (order.split_type != null && order.split_type.equalsIgnoreCase("order_item")) {
                    cartServiceCharge = 0;
                    // serviceChargeEnabled = false;
                    discountEnabled = false;
                    gratuityEnabled = false;
                }

                order.service_charge = cartServiceCharge;
                cartSubTotal = order.sub_total;
                cartDiscount = order.discount;
                cartGratuity = order.gratuity;

                if (discountEnabled) {
                    List<Discount> discounts = appDatabase.discountDao().eligibleDiscounts("%" + myApp.current_day + "%", "%" + order.order_type_id + "%", order.sub_total, CommonFunctions.getCurrentTimeFormatted("yyyy-MM-dd"), CommonFunctions.getCurrentTimeFormatted("yyyy-MM-dd"));
                    if (discounts.size() > 0) {
                        Discount appliedDiscount = discounts.get(0);
                        autoDiscountApplied = false;
                        if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("flat")) {
                            if (cartSubTotal > 0)
                                cartDiscount = appliedDiscount.discount;
                            else cartDiscount = 0;
                            autoDiscountApplied = true;
                        }
                        if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("percentage")) {
                            if (cartSubTotal > 0)
                                cartDiscount = cartSubTotal * appliedDiscount.discount / 100;
                            else cartDiscount = 0;
                            autoDiscountApplied = true;
                        }
                    } else {
                        if (autoDiscountApplied) cartDiscount = 0;
                    }
                }
                order.discount = cartDiscount;
                order.total = ((order.sub_total + order.gratuity + order.service_charge + order.delivery_charge) - order.discount);
                if (!order.order_status_id.equalsIgnoreCase("5") &&
                        !order.order_status_id.equalsIgnoreCase("10")) {
                    if (order.total == 0) {
                        order.order_status_id = "1";
                        order.order_status = "Taking Order";
                    } else if (CommonFunctions.orderPaymentStatus(order.total, order.total_paid) == 1) {
                        if (orderCompleteAuto) {
                            order.order_status_id = "5";
                            order.order_status = "Order Completed";
                        } else if (!order.order_status_id.equalsIgnoreCase("6")) {
                            order.order_status_id = "4";
                            order.order_status = "Order Paid";
                        }
                    } else if (order.total_paid > 0) {
                        order.order_status_id = "7";
                        order.order_status = "Part Payment Received";
                    } else {
                        if (!order.order_status_id.equalsIgnoreCase("3")) {
                            order.order_status_id = "2";
                            order.order_status = "Order Taken";
                        }
                    }
                    LogUtils.e("Updating TABLE onrefresh order status " + order.order_status);
                    order.updated_at = CommonFunctions.convertMsToDesiredFormat(System.currentTimeMillis(), Constants.PHP_DATE_TIME_FORMAT_ZULU);
                }
                myApp.appDatabase.orderDao().update(order);
                myApp.setOrderItems(orderItems);
                myApp.notifyCart(NewOrderActivity.this, new Intent(Constants.EPOS_CART_UPDATE).putExtra("notify_products", true));

                PaymentMethod voucherPaymentMethod = appDatabase.paymentMethodDao().view("5");
                if (order.split_type == null && voucherPaymentMethod != null && !voucherPaymentMethod.disabled) {
                    OrderPayment voucherPayment = appDatabase.orderPaymentDao().findByMethod(_order_id, "5");
                    voucherPaymentsEnabled = voucherPayment == null;
                    voucherPaymentDone = voucherPayment != null;
                } else {
                    voucherPaymentsEnabled = false;
                }
                if (!Validators.isNullOrEmpty(order.split_type) && order.split_type.equalsIgnoreCase("order_item")) {
                    int nonSplitedItemCount = appDatabase.orderItemDao().listNonSplitItemsCount(_order_id);
                    shouldOpenSplitScreen = nonSplitedItemCount > 0;
                } else {
                    shouldOpenSplitScreen = false;
                }
                if (!Validators.isNullOrEmpty(order.split_type) && order.split_type.equalsIgnoreCase("person")) {
                    canEditOrder = false;
                } else {
                    canEditOrder = CommonFunctions.orderPaymentStatus(order.total, order.total_paid) != 1;
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(Object s) {
            super.onPostExecute(s);
            if (order != null) {
                orderItemsAdapter.shouldEdit = canEditOrder;
                orderItemsAdapter.notifyDataSetChanged();
            }
            if (nextMethod != null) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private class AddOrUpdateOrderItemAsyncTask extends AsyncTask<Object, Object, Object> {
        Callable<Void> nextMethod;

        public AddOrUpdateOrderItemAsyncTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected Object doInBackground(Object... objects) {
            if (objects[0] instanceof OrderItem) {
                OrderItem orderItem = (OrderItem) objects[0];
                orderItem._order_id = _order_id;
                orderItem.order_id = order.id;
                orderItem.updater_id = myPreferences.getLoggedInUser().id;
                OrderItem itemToBeUpdated = null;
                if (selectedSplit == null || selectedSplit.paid_amount > 0) {
                    List<OrderItem> dbOrderItems = appDatabase.orderItemDao().findOldItemsToIncrementWithoutAddonsIngredient(_order_id, orderItem.product_id);
                    for (OrderItem dbOrderItem : dbOrderItems) {
                        boolean canWeUpdate = true;
                        dbOrderItem.order_item_addons = (ArrayList<OrderItemAddon>) appDatabase.orderItemAddonDao().list(dbOrderItem._id);
                        dbOrderItem.order_item_ingredients = (ArrayList<OrderItemIngredient>) appDatabase.orderItemIngredientDao().list(dbOrderItem._id);
                        String whyCantUpdate = "";
                        if (dbOrderItem.order_item_ingredients.size() > 0) {
                            canWeUpdate = false;
                        }
                        if (canWeUpdate) {
                            if (dbOrderItem.order_item_addons.size() == orderItem.order_item_addons.size()) {
                                // Check every addon;
                                for (OrderItemAddon orderItemAddon : orderItem.order_item_addons) {
                                    int addonIndex = dbOrderItem.order_item_addons.indexOf(orderItemAddon);
                                    if (addonIndex == -1) {
                                        canWeUpdate = false;
                                        break;
                                    }
                                    OrderItemAddon dbOrderItemAddon = dbOrderItem.order_item_addons.get(addonIndex);
                                    if (!dbOrderItemAddon.addon_id.equals(orderItemAddon.addon_id)) {
                                        canWeUpdate = false;
                                        break;
                                    }
                                    if (dbOrderItemAddon.quantity != orderItemAddon.quantity) {
                                        canWeUpdate = false;
                                        break;
                                    }
                                }
                            } else {
                                canWeUpdate = false;
                            }
                        }
                        if (canWeUpdate) {
                            itemToBeUpdated = dbOrderItem;
                            break;
                        }
                    }
                }

                if (itemToBeUpdated != null) {
                    itemToBeUpdated.quantity = itemToBeUpdated.quantity + orderItem.quantity;

                    float addonTotal = 0;
                    for (OrderItemAddon itemAddon : orderItem.order_item_addons) {
                        addonTotal = addonTotal + itemAddon.total;
                    }
                    float ingredientTotal = 0;
                    for (OrderItemIngredient itemIngredient : orderItem.order_item_ingredients) {
                        ingredientTotal = addonTotal + itemIngredient.total;
                    }
                    itemToBeUpdated.ingredients_price = ingredientTotal * itemToBeUpdated.quantity;
                    itemToBeUpdated.addons_price = addonTotal * itemToBeUpdated.quantity;
                    itemToBeUpdated.sub_total = itemToBeUpdated.quantity * itemToBeUpdated.price;
                    itemToBeUpdated.total = itemToBeUpdated.sub_total + itemToBeUpdated.addons_price + itemToBeUpdated.ingredients_price + (itemToBeUpdated.instruction_price * itemToBeUpdated.quantity);

                    appDatabase.orderItemDao().update(itemToBeUpdated);
                } else {
                    if (selectedSplit != null && selectedSplit.paid_amount == 0) {
                        orderItem._order_split_id = selectedSplit._id;
                        orderItem.order_split_id = selectedSplit.id;
                    }
                    int dbOrderItemId = 0;
                    if (orderItem._id > 0) {
                        appDatabase.orderItemDao().update(orderItem);
                        dbOrderItemId = orderItem._id;
                    } else {
                        dbOrderItemId = (int) appDatabase.orderItemDao().insert(orderItem);
                    }
                    float addonTotal = 0;
                    if (orderItem.order_item_addons != null) {
                        for (OrderItemAddon itemAddon : orderItem.order_item_addons) {
                            itemAddon._order_item_id = dbOrderItemId;
                            itemAddon.total = itemAddon.quantity * itemAddon.price;
                            addonTotal = addonTotal + itemAddon.total;
                        }
                        appDatabase.orderItemAddonDao().insertAll(orderItem.order_item_addons);
                    }

                    float ingredientTotal = 0;
                    if (orderItem.order_item_ingredients != null) {
                        for (OrderItemIngredient itemIngredient : orderItem.order_item_ingredients) {
                            itemIngredient._order_item_id = dbOrderItemId;
                            itemIngredient.total = itemIngredient.quantity * itemIngredient.price;
                            ingredientTotal = ingredientTotal + itemIngredient.total;
                        }
                        appDatabase.orderItemIngredientDao().insertAll(orderItem.order_item_ingredients);
                    }

                    ingredientTotal = ingredientTotal * orderItem.quantity;
                    addonTotal = addonTotal * orderItem.quantity;
                    appDatabase.orderItemDao().updateOrderItemTotal(dbOrderItemId, addonTotal, ingredientTotal);
                    if (selectedSplit != null && selectedSplit.paid_amount == 0) {
                        appDatabase.orderSplitDao().updateTotalAmount(orderItem._order_id, selectedSplit._id);
                    }
                }


            }
            return null;
        }

        @Override
        protected void onPostExecute(Object s) {
            super.onPostExecute(s);

            if (nextMethod != null) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private class UpdateCustomerAsynTask extends AsyncTask<Customer, String, String> {

        Callable<Void> nextMethod;

        public UpdateCustomerAsynTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected String doInBackground(Customer... customers) {
            Customer customer = customers[0];
            if (order.order_type_id.equalsIgnoreCase("1")) {
                order.no_guest = String.valueOf(customer.no_guest);
            } else {
                order.no_guest = "1";
            }

            if (customer._id == 0)
                customer._id = (int) appDatabase.customerDao().insert(customer);
            else
                appDatabase.customerDao().update(customer);


            Log.e("Distance", " " + customer.distance);
            order._customer_id = customer._id;
            order.customer_id = customer.id;
            order.customer_name = customer.name;
            order.customer.distance = customer.distance;
            order.updated_at = CommonFunctions.convertMsToDesiredFormat(System.currentTimeMillis(), Constants.PHP_DATE_TIME_FORMAT_ZULU);
            appDatabase.orderDao().update(order);

            Log.e("Distance", " " + order.customer.distance);
            shouldFetchDeliveryCharge = order.order_type_id.equalsIgnoreCase("3");

            return null;
        }

        @Override
        protected void onPostExecute(String c) {
            super.onPostExecute(c);
            if (nextMethod != null) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    class PrepLocationSenderAsync extends AsyncTask<String, String, String> {
        HashMap<PrepLocation, List<OrderItem>> prepOrderItems = new HashMap<>();
        String title;
        boolean updatedOrder;
        Callable<Void> nextMethod;

        public PrepLocationSenderAsync(String title, boolean updatedOrder, Callable<Void> nextMethod) {
            this.title = title;
            this.updatedOrder = updatedOrder;
            this.nextMethod = nextMethod;
        }

        @Override
        protected String doInBackground(String... strings) {

            ArrayList<PrepLocation> prepLocations = (ArrayList<PrepLocation>) appDatabase.prepLocationDao().list();
            for (PrepLocation prepLocation : prepLocations) {
                List<OrderItem> miscPrepOits = new ArrayList<>();
                List<OrderItem> prepOits = new ArrayList<>();
                List<OrderItem> allOits = new ArrayList<>();
                if (updatedOrder) {
                    if (order.order_type.equalsIgnoreCase("Collection")) {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsCollection(order._id, prepLocation.id, false);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsCollection(order._id, prepLocation.id, false);
                    } else if (order.order_type.equalsIgnoreCase("Delivery")) {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsDelivery(order._id, prepLocation.id, false);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsDelivery(order._id, prepLocation.id, false);
                    } else if (order.order_type.equalsIgnoreCase("Waiting")) {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsBanquet(order._id, prepLocation.id, false);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsBanquet(order._id, prepLocation.id, false);
                    } else {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocations(order._id, prepLocation.id, false);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocations(order._id, prepLocation.id, false);
                    }
                } else {
                    if (order.order_type.equalsIgnoreCase("Collection")) {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsCollection(order._id, prepLocation.id);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsCollection(order._id, prepLocation.id);
                    } else if (order.order_type.equalsIgnoreCase("Delivery")) {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsDelivery(order._id, prepLocation.id);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsDelivery(order._id, prepLocation.id);
                    } else if (order.order_type.equalsIgnoreCase("Waiting")) {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsBanquet(order._id, prepLocation.id);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsBanquet(order._id, prepLocation.id);
                    } else {
                        miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocations(order._id, prepLocation.id);
                        prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocations(order._id, prepLocation.id);
                    }
                }

                if (miscPrepOits != null && miscPrepOits.size() > 0) {
                    allOits.addAll(miscPrepOits);
                }

                if (prepOits != null && prepOits.size() > 0) {
                    allOits.addAll(prepOits);
                }
                if (allOits.size() > 0) {
                    prepOrderItems.put(prepLocation, allOits);
                    for (OrderItem oit : allOits) {
                        oit.sent_to_kitchen = true;
                        appDatabase.orderItemDao().update(oit);
                    }
                }
                for (Map.Entry<PrepLocation, List<OrderItem>> entry : prepOrderItems.entrySet()) {
                    for (OrderItem orderItem : (ArrayList<OrderItem>) entry.getValue()) {
                        orderItem.order_item_ingredients = (ArrayList<OrderItemIngredient>) appDatabase.orderItemIngredientDao().list(orderItem._id);
                        orderItem.order_item_addons = (ArrayList<OrderItemAddon>) appDatabase.orderItemAddonDao().list(orderItem._id);
                    }
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            int position = 0;
            for (Map.Entry<PrepLocation, List<OrderItem>> entry : prepOrderItems.entrySet()) {
                position++;
                PrepLocation prepLocation = entry.getKey();
                if (printers == null) {
                    ToastUtils.makeToast(NewOrderActivity.this, "Business printers are null");
                    continue;
                }
                Printer prepPrinter = null;
                for (Printer pp : printers) {
                    if (prepLocation.printer_id.equalsIgnoreCase(pp.id)) {
                        prepPrinter = pp;
                    }
                }
                if (prepPrinter == null) {
                    ToastUtils.makeToast(NewOrderActivity.this, "Preplocation printer not found,: " + prepLocation.printer_name);
                    continue;
                }
                if (defaultPrinter == null && forceFullyDefaultPrinter != null && prepPrinter.ip.equalsIgnoreCase(forceFullyDefaultPrinter.ip)) {
                    ToastUtils.makeToast(NewOrderActivity.this, "Preplocation printer also same as default and its not connected");
                    continue;
                }

                Order tempOrder = new Gson().fromJson(new Gson().toJson(order), Order.class);
                tempOrder.order_items = (ArrayList<OrderItem>) entry.getValue();
                Log.e("OrderItems", ":" + tempOrder.order_items.toString());

                if (tempOrder.order_items.size() > 0) {
                    if (prepPrinter.printer_model_name.toLowerCase().contains("88 h")) {
                        zoneRichPrinter.connectPrinter(prepPrinter.ip);
                        CommonFunctions.functionThatDelay(250);
                        zoneRichPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, true, false);
                        if (buzzerSetting != null && !Validators.isNullOrEmpty(buzzerSetting.value) && buzzerSetting.value.equalsIgnoreCase("yes") && prepLocation.cash_draw) {
                            zoneRichPrinter.connectPrinter(prepPrinter.ip);
                            CommonFunctions.functionThatDelay(250);
                            zoneRichPrinter.openCashDrawer();
                        }
                    } else if (prepPrinter.printer_model_name.toLowerCase().contains("t2") || prepPrinter.printer_model_name.toLowerCase().contains("sunmi")) {
                        sunmiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, true, false);
                        if (buzzerSetting != null && !Validators.isNullOrEmpty(buzzerSetting.value) && buzzerSetting.value.equalsIgnoreCase("yes") && prepLocation.cash_draw) {
                            sunmiPrinter.openCashDrawer();
                        }
                    } else if (prepPrinter.printer_model_name.toLowerCase().contains("pos-80") || prepPrinter.printer_model_name.toLowerCase().contains("pos 80") || prepPrinter.printer_model_name.toLowerCase().contains("yoke4")) {
                        wifiPrinter.disconnect();
                        CommonFunctions.functionThatDelay(200);
                        wifiPrinter.connect(prepPrinter.ip);
                        CommonFunctions.functionThatDelay(200);
                        if (buzzerSetting != null && !Validators.isNullOrEmpty(buzzerSetting.value) && buzzerSetting.value.equalsIgnoreCase("yes") && prepLocation.cash_draw) {
                            wifiPrinter.openCashDrawer(false);
                        }
                        wifiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, true, false);
                    }
                }
            }
            if (position >= prepOrderItems.size()) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            myApp.isCashDrawerOpen = false;
        }
    }

    class OrderItemsPrintBlockAsync extends AsyncTask<Integer, Integer, Integer> {
        String title;
        ArrayList<OrderItem> groupedOrderItems = new ArrayList<>();
        Callable<Void> nextMethod;


        public OrderItemsPrintBlockAsync(String title, Callable<Void> nextMethod) {
            this.title = title;
            this.nextMethod = nextMethod;
        }

        @Override
        protected Integer doInBackground(Integer... integers) {
            List<OrderItem> miscOrderItems;
            List<OrderItem> productOrderItems;

            int _split_id = 0;
            if (integers.length > 0) {
                _split_id = integers[0];
                miscOrderItems = appDatabase.orderItemDao().orderItemsMiscForPrint(order._id, _split_id);
                productOrderItems = appDatabase.orderItemDao().orderItemProductForPrint(order._id, _split_id);
            } else {
                miscOrderItems = appDatabase.orderItemDao().orderItemsMiscForPrint(order._id);
                productOrderItems = appDatabase.orderItemDao().orderItemProductForPrint(order._id);
            }

            if (miscOrderItems != null && miscOrderItems.size() > 0) {
                groupedOrderItems.addAll(miscOrderItems);
            }

            if (productOrderItems != null && productOrderItems.size() > 0) {
                groupedOrderItems.addAll(productOrderItems);
            }

            for (int i = 0; i < groupedOrderItems.size(); i++) {
                OrderItem orderItems_object = groupedOrderItems.get(i);
                orderItems_object.order_item_ingredients = (ArrayList<OrderItemIngredient>) appDatabase.orderItemIngredientDao().list(orderItems_object._id);
                orderItems_object.order_item_addons = (ArrayList<OrderItemAddon>) appDatabase.orderItemAddonDao().list(orderItems_object._id);
                groupedOrderItems.set(i, orderItems_object);
            }

            if (_split_id > 0) {
                OrderSplit orderSplit = appDatabase.orderSplitDao().view(_split_id);
                order.total = orderSplit.total;
            }

            return 0;
        }

        @Override
        protected void onPostExecute(Integer integer) {
            super.onPostExecute(integer);
            Order tempOrder = new Gson().fromJson(new Gson().toJson(order), Order.class);
            if (splitByPersonPrint) {
                tempOrder.total = printableTotal;
            }

            tempOrder.order_items = groupedOrderItems;
            if (defaultPrinter.printer_model_name.toLowerCase().contains("88 h")) {
                zoneRichPrinter.connectPrinter(defaultPrinter.ip);
                CommonFunctions.functionThatDelay(250);
                zoneRichPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, true, footerA, footerB, false, false);
            } else if (defaultPrinter.printer_model_name.toLowerCase().contains("t2") || defaultPrinter.printer_model_name.toLowerCase().contains("sunmi")) {
                sunmiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, true, footerA, footerB, false, false);
            } else if (defaultPrinter.printer_model_name.toLowerCase().contains("pos-80") || defaultPrinter.printer_model_name.toLowerCase().contains("pos 80") || defaultPrinter.printer_model_name.toLowerCase().contains("yoke4")) {
                CommonFunctions.functionThatDelay(200);
                wifiPrinter.connect(defaultPrinter.ip);
                CommonFunctions.functionThatDelay(200);
                wifiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, false, false);
            }
            myApp.isCashDrawerOpen = false;
            try {
                nextMethod.call();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
