package com.example.epos_2021.activities;

import android.content.BroadcastReceiver;
import android.content.Intent;
import android.os.Bundle;

import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;
import androidx.localbroadcastmanager.content.LocalBroadcastManager;

import com.example.epos_2021.R;
import com.example.epos_2021.base.BaseActivity;
import com.example.epos_2021.fragment.CartProductEditDialogFragment;
import com.example.epos_2021.utils.Constants;
import com.example.epos_2021.utils.LogUtils;


/**
 * Created by Amrish on 26-08-2020.
 */
public class TransportActivity extends BaseActivity {
    private String destination, screenName;
    BroadcastReceiver broadcastReceiver;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        handleNavigation();
        setListeners();
    }

    @Override
    protected void manageIntents() {
        super.manageIntents();
        if (getIntent() != null) {
            destination = getIntent().getStringExtra("destination");
            screenName = getIntent().getStringExtra("name");

        }
    }

    @Override
    protected void setXML() {
        super.setXML();
        setContentView(R.layout.activity_transport);
    }

    @Override
    protected void initViews() {
        super.initViews();
    }

    private void handleNavigation() {
        if (destination.equalsIgnoreCase("cart_product_edit")) {
            changeFragment(CartProductEditDialogFragment.getInstance());
        }

    }

    private void setListeners() {
    }


    private void changeFragment(Fragment fragment) {
        if (getIntent() != null) {
            fragment.setArguments(getIntent().getExtras());
        }
        FragmentManager manager = getSupportFragmentManager();
        FragmentTransaction transaction = manager.beginTransaction();
        transaction.replace(R.id.flContainer, fragment);
        transaction.commit();
    }

    @Override
    protected void onResume() {
        super.onResume();
    }


    @Override
    public void onBackPressed() {

        if (!isTaskRoot()) {
            super.onBackPressed();
        } else {
            finish();
        }

    }

    @Override
    protected void onStop() {
        LocalBroadcastManager.getInstance(this).unregisterReceiver(broadcastReceiver);
        super.onStop();

    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == Constants.CODE_DATA_RECEIVE && resultCode == RESULT_OK) {
            if (data != null) {
                setResult(RESULT_OK, data);
                LogUtils.e("intent received");


            }
        }
    }
}
