package com.example.epos_2021.adapters;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.epos_2021.MyApp;
import com.example.epos_2021.R;
import com.example.epos_2021.interfaces.RecyclerviewItemClickListener;
import com.example.epos_2021.models.OrderItemAddon;

import java.util.ArrayList;

public class SelectedAddonAdapter extends RecyclerView.Adapter<SelectedAddonAdapter.ViewHolder> {

    private ArrayList<OrderItemAddon> productAddons;
    private RecyclerviewItemClickListener deleteClickListener;

    public SelectedAddonAdapter(ArrayList<OrderItemAddon> productAddons, RecyclerviewItemClickListener deleteClickListener) {
        this.productAddons = productAddons;
        this.deleteClickListener = deleteClickListener;
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new ViewHolder(LayoutInflater.from(parent.getContext()).inflate(R.layout.item_selectedaddon, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull SelectedAddonAdapter.ViewHolder holder, int position) {

        OrderItemAddon orderItemAddon = productAddons.get(position);
        holder.tvSelectedAddons.setText(orderItemAddon.addon_name + " ( " + MyApp.currencySymbol + MyApp.df.format(orderItemAddon.price) + " ) ");
        holder.ivDelete.setOnClickListener(v -> {
            if (deleteClickListener != null) {
                deleteClickListener.onItemClick(position, orderItemAddon);
            }
        });
    }

    @Override
    public int getItemCount() {
        return productAddons.size();
    }


    public static class ViewHolder extends RecyclerView.ViewHolder {
        TextView tvSelectedAddons;
        ImageView ivDelete;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            ivDelete = itemView.findViewById(R.id.ivDelete);
            tvSelectedAddons = itemView.findViewById(R.id.tvSelectedAddons);
        }
    }
}
