package com.example.epos_2021.base;

import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.view.Window;
import android.view.WindowManager;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;

import com.example.epos_2021.MyApp;
import com.example.epos_2021.daos.AppDatabase;
import com.example.epos_2021.models.Business;
import com.example.epos_2021.storageutils.MyPreferences;
import com.example.epos_2021.utils.LogUtils;

public class BaseActivity extends AppCompatActivity {
    public MyApp myApp = MyApp.getInstance();
    public MyPreferences myPreferences = myApp.myPreferences;
    public AppDatabase appDatabase = myApp.appDatabase;
    public Business selectedBusiness;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        manageIntents();
        setXML();

        initViews();
    }

    protected void manageIntents() {
        Bundle bundle = getIntent().getExtras();
        if (bundle != null) {
            for (String key : bundle.keySet()) {
                LogUtils.w("##EXTRAS##", key + " : " + (bundle.get(key) != null ? bundle.get(key) : "NULL"));
            }
        }
    }

    protected void setXML() {

    }

    protected void initViews() {
        if (myPreferences.getLoggedInAdmin() != null)
            selectedBusiness = myPreferences.getLoggedInAdmin().selected_business;
    }

    @Override
    public boolean onSupportNavigateUp() {
        onBackPressed();
        return super.onSupportNavigateUp();
    }

    protected void changeStatusBarColor(int color) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            Window window = getWindow();
            window.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
            window.setStatusBarColor(color);
        }
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (!myApp.isConnected(this)) {
            changeStatusBarColor(Color.RED);
        } else {
            changeStatusBarColor(Color.BLACK);
        }
    }
}
