package com.example.epos_2021.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.epos_2021.R;
import com.example.epos_2021.adapters.ModifyItemAdapter;
import com.example.epos_2021.base.BaseFragment;
import com.example.epos_2021.models.Starters;

import java.util.ArrayList;

public class AcceptOrderFragment extends BaseFragment {

    private TextView tvItemName, tvPrice, tvDescription, tvQty, tvModifiedQty, tvInstruction, tvSubPrice;
    private ImageView ivPlus, ivMinus, ivSecPlus, ivSecMinus;
    private RadioButton rbMainBar, rbKitchen, rbBar2;
    private LinearLayout llMainBar, llKitchen, llBar2;
    private RecyclerView rvItems;

    private ArrayList<Starters> items = new ArrayList<>();
    private ModifyItemAdapter itemAdapter;
    private int count = 1;
    private int modifiedCount = 1;

    public static AcceptOrderFragment getInstance() {
        return new AcceptOrderFragment();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.fragment_accept_order, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        initViews(view);
        setListeners();
    }

    private void setListeners() {
        ivPlus.setOnClickListener(view -> {
            count++;
            tvQty.setText(String.valueOf(count));
        });
        ivMinus.setOnClickListener(view -> {
            if (count > 1) {
                count--;
                tvQty.setText(String.valueOf(count));
            }
        });

        ivSecPlus.setOnClickListener(view -> {
            modifiedCount++;
            tvModifiedQty.setText(String.valueOf(modifiedCount));
        });
        ivSecMinus.setOnClickListener(view -> {
            if (modifiedCount > 1) {
                modifiedCount--;
                tvModifiedQty.setText(String.valueOf(modifiedCount));
            }
        });
        llMainBar.setOnClickListener(v -> {
            rbMainBar.setChecked(true);
            rbKitchen.setChecked(false);
            rbBar2.setChecked(false);
        });

        llKitchen.setOnClickListener(v -> {
            rbMainBar.setChecked(false);
            rbKitchen.setChecked(true);
            rbBar2.setChecked(false);
        });

        llBar2.setOnClickListener(v -> {
            rbMainBar.setChecked(false);
            rbKitchen.setChecked(false);
            rbBar2.setChecked(true);
        });

        rbMainBar.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked) {
                llMainBar.performClick();
            }
        });
        rbKitchen.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked)
                llKitchen.performClick();
        });
        rbBar2.setOnCheckedChangeListener((buttonView, isChecked) -> {
            if (isChecked)
                llBar2.performClick();
        });

    }

    private void initViews(View view) {

        tvItemName = view.findViewById(R.id.tvItemName);
        tvPrice = view.findViewById(R.id.tvPrice);
        tvDescription = view.findViewById(R.id.tvDescription);
        tvQty = view.findViewById(R.id.tvQty);
        tvModifiedQty = view.findViewById(R.id.tvModifyQty);
        tvInstruction = view.findViewById(R.id.tvInstruction);
        tvSubPrice = view.findViewById(R.id.tvSubPrice);

        ivMinus = view.findViewById(R.id.ivDecrease);
        ivPlus = view.findViewById(R.id.ivIncrease);
        ivSecMinus = view.findViewById(R.id.ivSecDecrease);
        ivSecPlus = view.findViewById(R.id.ivSecIncrease);

        rbMainBar = view.findViewById(R.id.rbMainBar);
        rbKitchen = view.findViewById(R.id.rbKitchen);
        rbBar2 = view.findViewById(R.id.rbBar2);

        llMainBar = view.findViewById(R.id.llMainBar);
        llKitchen = view.findViewById(R.id.llKitchen);
        llBar2 = view.findViewById(R.id.llBar2);

        rvItems = view.findViewById(R.id.rvItems);

        itemAdapter = new ModifyItemAdapter(getActivity(), items, (position, data) -> {
        });
        rvItems.setLayoutManager(new GridLayoutManager(getActivity(), 3));
        rvItems.setAdapter(itemAdapter);

    }
}
