package com.example.epos_2021.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;

import com.example.epos_2021.R;
import com.example.epos_2021.interfaces.DialogDismissListener;
import com.google.android.material.button.MaterialButton;

public class AddQuantityDialogFragment extends DialogFragment {

    @Override
    public int getTheme() {
        return R.style.MyDialog;
    }

    @Override
    public void onStart() {
        super.onStart();
        getDialog().setCancelable(false);
        getDialog().getWindow().setLayout(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.WRAP_CONTENT);
    }

    private DialogDismissListener dialogDismissListener;
    int quantity = 1;

    public static AddQuantityDialogFragment getInstance(int quantity) {
        AddQuantityDialogFragment fragment = new AddQuantityDialogFragment();
        Bundle bundle = new Bundle();
        bundle.putInt("quantity", quantity);
        fragment.setArguments(bundle);
        return fragment;
    }

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }

    private ImageView ivPlus, ivMinus;
    private TextView tvQuantity;
    private MaterialButton btnConfirm, btnCancel;
    private MaterialButton btnQty2, btnQty4, btnQty6, btnQty8, btnQty10, btnQty15, btnQty20, btnQty25;
    private MaterialButton btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9, btn0;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        return inflater.inflate(R.layout.fragment_add_quantity_dialog, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if (getArguments() != null) {
            quantity = getArguments().getInt("quantity", 1);
        }
        initViews(view);
        setListeners();
    }

    private void initViews(View view) {

        btnCancel = view.findViewById(R.id.btnCancel);
        btnConfirm = view.findViewById(R.id.btnConfirm);
        btnQty2 = view.findViewById(R.id.btnQty2);
        btnQty4 = view.findViewById(R.id.btnQty4);
        btnQty6 = view.findViewById(R.id.btnQty6);
        btnQty8 = view.findViewById(R.id.btnQty8);
        btnQty10 = view.findViewById(R.id.btnQty10);
        btnQty15 = view.findViewById(R.id.btnQty15);
        btnQty20 = view.findViewById(R.id.btnQty20);
        btnQty25 = view.findViewById(R.id.btnQty25);
        btn1 = view.findViewById(R.id.btn1);
        btn2 = view.findViewById(R.id.btn2);
        btn3 = view.findViewById(R.id.btn3);
        btn4 = view.findViewById(R.id.btn4);
        btn5 = view.findViewById(R.id.btn5);
        btn6 = view.findViewById(R.id.btn6);
        btn7 = view.findViewById(R.id.btn7);
        btn8 = view.findViewById(R.id.btn8);
        btn9 = view.findViewById(R.id.btn9);
        btn0 = view.findViewById(R.id.btn0);
        ivPlus = view.findViewById(R.id.ivPlus);
        ivMinus = view.findViewById(R.id.ivMinus);
        tvQuantity = view.findViewById(R.id.tvQuantity);
        tvQuantity.setText(String.valueOf(quantity));

    }

    private void setListeners() {

        btn1.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(1));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn2.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(2));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn3.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(3));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn4.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(4));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn5.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(5));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn6.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(6));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn7.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(7));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn8.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(8));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn9.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(9));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btn0.setOnClickListener(v -> {
            tvQuantity.setText(tvQuantity.getText() + String.valueOf(0));
            quantity = Integer.parseInt(tvQuantity.getText().toString());
        });

        btnQty2.setOnClickListener(v -> {
            quantity = 2;
            tvQuantity.setText(String.valueOf(quantity));
        });

        btnQty4.setOnClickListener(v -> {
            quantity = 4;
            tvQuantity.setText(String.valueOf(quantity));
        });
        btnQty6.setOnClickListener(v -> {
            quantity = 6;
            tvQuantity.setText(String.valueOf(quantity));
        });
        btnQty8.setOnClickListener(v -> {
            quantity = 8;
            tvQuantity.setText(String.valueOf(quantity));
        });
        btnQty10.setOnClickListener(v -> {
            quantity = 10;
            tvQuantity.setText(String.valueOf(quantity));
        });
        btnQty15.setOnClickListener(v -> {
            quantity = 15;
            tvQuantity.setText(String.valueOf(quantity));
        });
        btnQty20.setOnClickListener(v -> {
            quantity = 20;
            tvQuantity.setText(String.valueOf(quantity));
        });
        btnQty25.setOnClickListener(v -> {
            quantity = 25;
            tvQuantity.setText(String.valueOf(quantity));
        });

        ivPlus.setOnClickListener(view -> {
            quantity = Integer.parseInt(tvQuantity.getText().toString()) + 1;
            tvQuantity.setText("" + quantity);
        });

        ivMinus.setOnClickListener(view -> {
            if (quantity > 1) {
                quantity = Integer.parseInt(tvQuantity.getText().toString()) - 1;
                tvQuantity.setText("" + quantity);
            }
        });

        btnCancel.setOnClickListener(view -> {
            dismiss();
        });

        btnConfirm.setOnClickListener(view -> {
            quantity = Integer.parseInt(tvQuantity.getText().toString());
            dialogDismissListener.onDialogDismiss(quantity);
            dismiss();
        });

    }

}