package com.example.epos_2021.fragment;

import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.AppCompatImageView;
import androidx.fragment.app.DialogFragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.epos_2021.MyApp;
import com.example.epos_2021.R;
import com.example.epos_2021.adapters.OrderPaymentsAdapter;
import com.example.epos_2021.comman.CommonFunctions;
import com.example.epos_2021.comman.Validators;
import com.example.epos_2021.comman.printer.SunmiPrinter;
import com.example.epos_2021.comman.printer.WifiPrinter;
import com.example.epos_2021.comman.printer.ZoneRichPrinter;
import com.example.epos_2021.daos.AppDatabase;
import com.example.epos_2021.daos.relations.OrderItemWithAddonsIngredients;
import com.example.epos_2021.daos.relations.OrderWithItems;
import com.example.epos_2021.interfaces.RecyclerviewItemClickListenerWithTag;
import com.example.epos_2021.merchant.adapters.EposOrderedProductItemsAdapter;
import com.example.epos_2021.models.Admin;
import com.example.epos_2021.models.Business;
import com.example.epos_2021.models.Discount;
import com.example.epos_2021.models.Order;
import com.example.epos_2021.models.OrderItem;
import com.example.epos_2021.models.OrderItemAddon;
import com.example.epos_2021.models.OrderItemIngredient;
import com.example.epos_2021.models.OrderPayment;
import com.example.epos_2021.models.OrderSplit;
import com.example.epos_2021.models.PrepLocation;
import com.example.epos_2021.models.Printer;
import com.example.epos_2021.models.SiteSetting;
import com.example.epos_2021.models.Table;
import com.example.epos_2021.models.TableStatus;
import com.example.epos_2021.online.fragments.EnterPasswordDialogFragment;
import com.example.epos_2021.online.interfaces.DialogDismissListener;
import com.example.epos_2021.services.SingleOrderUploaderService;
import com.example.epos_2021.utils.Constants;
import com.example.epos_2021.utils.LogUtils;
import com.example.epos_2021.utils.ToastUtils;
import com.google.android.material.button.MaterialButton;
import com.google.android.material.card.MaterialCardView;
import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Callable;

public class EposCompletedOrderOverviewBottomSheet extends DialogFragment {

    private int order_type = -1; // 0 dinein, 1 delivery, 2 pickup
    private RecyclerView rvPayment;
    private LinearLayout llLoading;
    private MaterialButton btnPrint, btnClose, btnCancelOrder;
    private DialogDismissListener dialogDismissListener;
    private LinearLayout llMainLayout;

    private TextView tvSubTotal, tvServiceCharge, tvDeliveryFee, tvDiscount, tvGratuityAmount;
    private TextView tvCustomerName, tvPhoneNo, tvAddress, tvInstructions, tvInstructionTitle;
    private MaterialCardView cvInstructions;

    private LinearLayout llDiscount, llDeliveryFee, llServiceCharge, llGratuity;
    private TextView tvOrderNumber, tvOrderPaymentStatus, tvOrderDate, tvDeliveryTime, tvMiles, tvTotal;
    private RecyclerView rvCartItems;
    private EposOrderedProductItemsAdapter productItemsAdapter;
    private OrderPaymentsAdapter paymentsAdapter;
    private ArrayList<OrderItem> orderItems = new ArrayList<>();
    private ArrayList<OrderPayment> orderPayments = new ArrayList<>();
    private int _order_id;
    private boolean printTotalInPrint = true;
    private SiteSetting buzzerSetting, ticketHeaderSetting, ticketHeaderTypeSetting, tableOrOrderIdSetting, orderDateTimeSetting, footerASetting, footerBSetting, totalVisibilitySetting, serviceChargeEnableSetting, serviceChargeOptionSetting, serviceChargeSetting, serviceChargeTypeSetting;
    private OrderWithItems orderWithItems;
    private Order order = new Order();
    private ArrayList<Printer> printers = new ArrayList<>();
    private boolean serviceChargeEnabled = false, serviceChargeAutoMode = true, discountEnabled = true, gratuityEnabled = true, autoDiscountApplied = false;
    private WifiPrinter wifiPrinter;
    private ZoneRichPrinter zoneRichPrinter;
    private SunmiPrinter sunmiPrinter;
    protected MyApp myApp = MyApp.getInstance();
    private AppDatabase appDatabase = myApp.appDatabase;
    protected AppCompatImageView ivClose;
    protected Admin loggedInAdmin = myApp.myPreferences.getLoggedInAdmin();
    protected Business selectedBusiness = loggedInAdmin.selected_business;
    protected Printer defaultPrinter;
    private Printer forceFullyDefaultPrinter;
    private int headerAlignment = 0;
    private String dateTimeModeInPrint;
    private String footerA, footerB;
    private LinearLayout llData;
    private float cartGrandTotal = 0, cartSubTotal = 0, cartDiscount = 0, cartServiceCharge = 0;
    public TableStatus vacantStatus = myApp.findStatus("Vacant");
    private ArrayList<Object> objects = new ArrayList<>();
    private OrderSplit selectedSplit;

    public static EposCompletedOrderOverviewBottomSheet getInstance(int orderId) {
        EposCompletedOrderOverviewBottomSheet overviewBottomSheet = new EposCompletedOrderOverviewBottomSheet();
        Bundle bundle = new Bundle();
        bundle.putInt("_order_id", orderId);
        overviewBottomSheet.setArguments(bundle);
        return overviewBottomSheet;
    }

    @Override
    public int getTheme() {
        return R.style.MyBottomTopDialog;
    }

    @Override
    public void onStart() {
        super.onStart();
        getDialog().getWindow().setLayout(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT);
        getDialog().getWindow().setGravity(Gravity.BOTTOM);
    }

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }


    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        if (getArguments() != null) {
            _order_id = getArguments().getInt("_order_id");
        }
        return inflater.inflate(R.layout.fragment_epos_order_overview, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        initViews(view);
        setListeners();
        if (_order_id > 0) {
            fetchOffline();
        }
    }

    private void setListeners() {
        ivClose.setOnClickListener(view -> dismiss());
        btnClose.setOnClickListener(v -> dismiss());
        btnPrint.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                createPrint("", false, true);
            }
        });
        btnCancelOrder.setOnClickListener(view -> {
            cancelOrderAction();
        });
    }

    private void cancelOrderAction() {
        ConfirmationDialogFragment confirmationDialogFragment = ConfirmationDialogFragment.getInstance("Cancel order", "Are you sure you want to cancel this order?", 2, "Confim", "Cancel");
        confirmationDialogFragment.show(getActivity().getSupportFragmentManager(), "cancel_order_menu");
        confirmationDialogFragment.setDialogDismissListener(o -> {
            if (o instanceof String && ((String) o).equalsIgnoreCase("confirm")) {

                if (order.total_paid > 0) {
                    EnterPasswordDialogFragment enterPasswordDialogFragment = EnterPasswordDialogFragment.getInstance(null, "Please enter password", "Please enter password to cancel this order");
                    enterPasswordDialogFragment.show(getActivity().getSupportFragmentManager(), "password");
                    enterPasswordDialogFragment.setDialogDismissListener(o1 -> {
                        if (o1 instanceof String) {
                            String password = (String) o1;
                            if (password.equalsIgnoreCase(myApp.myPreferences.getLoggedInUser().password)) {
                                order.order_status = "Order Rejected";
                                order.order_status_id = "10";
                                ToastUtils.showSnackBar(getActivity(), llMainLayout, "Order rejected", "reject");
                                new UpdateOrderAsyncTask(() -> {
                                    updateViews();
                                    uploadOrder();
                                    dismiss();
                                    return null;
                                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                            } else {
                                ToastUtils.makeSnackToast(getActivity(), "Incorrect password");
                            }
                        }
                    });
                } else {
                    order.order_status = "Order Rejected";
                    order.order_status_id = "10";
                    ToastUtils.showSnackBar(getActivity(), llMainLayout, "Order rejected", "reject");
                    new UpdateOrderAsyncTask(() -> {
                        updateViews();
                        uploadOrder();
                        dismiss();
                        return null;
                    }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
                }
            }
        });
    }

    private void uploadOrder() {
        if (getActivity() != null) {
            Intent intent = new Intent(getActivity(), SingleOrderUploaderService.class);
            intent.putExtra("_order_id", _order_id);
            getActivity().startService(intent);
        }
    }

    private class UpdateOrderAsyncTask extends AsyncTask<Object, Object, Object> {
        Callable<Void> nextMethod;

        public UpdateOrderAsyncTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected Object doInBackground(Object... objects) {
            order.sub_total = myApp.appDatabase.orderDao().getItemSubTotal(order._id);

            cartSubTotal = order.sub_total;
            if (serviceChargeEnabled) {
                if (serviceChargeAutoMode) {
                    float serviceChargeValue = Float.parseFloat(serviceChargeSetting.value);
                    if (serviceChargeTypeSetting.value.equalsIgnoreCase("flat")) {
                        cartServiceCharge = serviceChargeValue;
                    } else {
                        if (serviceChargeValue > 0) {
                            cartServiceCharge = cartSubTotal * serviceChargeValue / 100;
                        } else {
                            cartServiceCharge = 0;
                        }
                    }
                }
            }

            if (discountEnabled) {
                List<Discount> discounts = appDatabase.discountDao().eligibleDiscounts("%" + myApp.current_day + "%", "%" + order.order_type_id + "%", order.sub_total, CommonFunctions.getCurrentTimeFormatted("yyyy-MM-dd"), CommonFunctions.getCurrentTimeFormatted("yyyy-MM-dd"));
                if (discounts.size() > 0) {
                    Discount appliedDiscount = discounts.get(0);
                    autoDiscountApplied = false;
                    if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("flat")) {
                        if (cartSubTotal > 0)
                            cartDiscount = appliedDiscount.discount;
                        else cartDiscount = 0;
                        autoDiscountApplied = true;
                    }
                    if (!Validators.isNullOrEmpty(appliedDiscount.discount_type) && appliedDiscount.discount_type.equalsIgnoreCase("percentage")) {
                        if (cartSubTotal > 0)
                            cartDiscount = cartSubTotal * appliedDiscount.discount / 100;
                        else cartDiscount = 0;
                        autoDiscountApplied = true;
                    }
                } else {
                    if (autoDiscountApplied) cartDiscount = 0;
                }
            }


            order.discount = cartDiscount;
            order.service_charge = cartServiceCharge;
            cartGrandTotal = cartSubTotal + order.gratuity - cartDiscount + cartServiceCharge + order.delivery_charge;
            order.total = cartGrandTotal;
            if (!order.order_status_id.equalsIgnoreCase("5") && !order.order_status_id.equalsIgnoreCase("10")) {
                order.updated_at = CommonFunctions.convertMsToDesiredFormat(System.currentTimeMillis(), Constants.PHP_DATE_TIME_FORMAT_ZULU);
            }
            appDatabase.orderDao().update(order);

            if (order.order_type_id.equalsIgnoreCase("1") && !Validators.isNullOrEmpty(order.table_id) && (order.order_status_id.equalsIgnoreCase("5") || order.order_status_id.equalsIgnoreCase("10"))) {
                Table table = appDatabase.tableDao().view(order.table_id);
                table.status = vacantStatus.status;
                table.last_order_total = 0;
                table.last_order_id = null;
                table._last_order_id = 0;
                table.last_order_created_at = null;
                table.table_status_id = vacantStatus.id;
                appDatabase.tableDao().insert(table);
            }
            return null;
        }

        @Override
        protected void onPostExecute(Object s) {
            super.onPostExecute(s);
            if (nextMethod != null) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private void createPrint(String title, boolean kitchenCopy, boolean goBack) {
        if (kitchenCopy) {
            print(title, true);
            return;
        }
        if (defaultPrinter != null && defaultPrinter.printer_model_name != null) {
            print(title, false);
        } else {
            dismiss();
            ToastUtils.makeLongToast(getActivity(), "No printer model found");
        }
    }

    private void print(String title, boolean kitchenCopy) {
        if (myApp.isCashDrawerOpen && !kitchenCopy) {
            if (defaultPrinter.printer_model_name.toLowerCase().contains("88 h") || defaultPrinter.printer_model_name.toLowerCase().contains("pos-80") || defaultPrinter.printer_model_name.toLowerCase().contains("pos 80") || defaultPrinter.printer_model_name.toLowerCase().contains("yoke4")) {
                zoneRichPrinter.connectPrinter(defaultPrinter.ip);
                zoneRichPrinter.openCashDrawer();
            } else if (defaultPrinter.printer_model_name.toLowerCase().contains("t2") || defaultPrinter.printer_model_name.toLowerCase().contains("sunmi")) {
                sunmiPrinter.openCashDrawer();
            }
            myApp.isCashDrawerOpen = false;
        }
        if (kitchenCopy) {
            new PrepLocationSenderAsync(title, () -> {
                dismiss();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        } else {
            new OrderItemsPrintBlockAsync(null, () -> {
                dismiss();
                return null;
            }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
        }
    }

    class PrepLocationSenderAsync extends AsyncTask<String, String, String> {
        HashMap<PrepLocation, List<OrderItem>> prepOrderItems = new HashMap<>();
        String title;
        Callable<Void> nextMethod;

        public PrepLocationSenderAsync(String title, Callable<Void> nextMethod) {
            this.title = title;
            this.nextMethod = nextMethod;
        }

        @Override
        protected String doInBackground(String... strings) {

            ArrayList<PrepLocation> prepLocations = (ArrayList<PrepLocation>) appDatabase.prepLocationDao().list();
            for (PrepLocation prepLocation : prepLocations) {
                List<OrderItem> miscPrepOits = new ArrayList<>();
                List<OrderItem> prepOits = new ArrayList<>();
                List<OrderItem> allOits = new ArrayList<>();

                if (order.order_type.equalsIgnoreCase("Collection")) {
                    miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsCollection(order._id, prepLocation.id);
                    prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsCollection(order._id, prepLocation.id);
                } else if (order.order_type.equalsIgnoreCase("Delivery")) {
                    miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsDelivery(order._id, prepLocation.id);
                    prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsDelivery(order._id, prepLocation.id);
                } else if (order.order_type.equalsIgnoreCase("Waiting")) {
                    miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocationsBanquet(order._id, prepLocation.id);
                    prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocationsBanquet(order._id, prepLocation.id);
                } else {
                    miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocations(order._id, prepLocation.id);
                    prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocations(order._id, prepLocation.id);
                }
               /* miscPrepOits = appDatabase.orderItemDao().orderItemsForPrepLocations(order._id,prepLocation.id);
                prepOits = appDatabase.orderItemDao().orderItemProductForPrepLocations(order._id, prepLocation.id);*/

                if (miscPrepOits != null && miscPrepOits.size() > 0) {
                    allOits.addAll(miscPrepOits);
                }

                if (prepOits != null && prepOits.size() > 0) {
                    allOits.addAll(prepOits);
                }
                if (allOits.size() > 0) {
                    prepOrderItems.put(prepLocation, allOits);
                    for (OrderItem oit : allOits) {
                        oit.sent_to_kitchen = true;
                        appDatabase.orderItemDao().update(oit);
                    }
                }

                for (Map.Entry<PrepLocation, List<OrderItem>> entry : prepOrderItems.entrySet()) {
                    for (OrderItem orderItem : (ArrayList<OrderItem>) entry.getValue()) {
                        orderItem.order_item_ingredients = (ArrayList<OrderItemIngredient>) appDatabase.orderItemIngredientDao().list(orderItem._id);
                        orderItem.order_item_addons = (ArrayList<OrderItemAddon>) appDatabase.orderItemAddonDao().list(orderItem._id);
                    }
                }

            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            int position = 0;
            for (Map.Entry<PrepLocation, List<OrderItem>> entry : prepOrderItems.entrySet()) {
                position++;
                PrepLocation prepLocation = entry.getKey();
                if (printers == null) {
                    ToastUtils.makeToast(getActivity(), "Business printers are null");
                    continue;
                }
                Printer prepPrinter = null;
                for (Printer pp : printers) {
                    if (prepLocation.printer_id.equalsIgnoreCase(pp.id)) {
                        prepPrinter = pp;
                    }
                }
                if (prepPrinter == null) {
                    ToastUtils.makeToast(getActivity(), "Preplocation printer not found,: " + prepLocation.printer_name);
                    continue;
                }
                if (defaultPrinter == null && forceFullyDefaultPrinter != null && prepPrinter.ip.equalsIgnoreCase(forceFullyDefaultPrinter.ip)) {
                    ToastUtils.makeToast(getActivity(), "Preplocation printer also same as default and its not connected");
                    continue;
                }

                Order tempOrder = new Gson().fromJson(new Gson().toJson(order), Order.class);
                tempOrder.order_items = (ArrayList<OrderItem>) entry.getValue();

                if (tempOrder.order_items.size() > 0) {
                    if (prepPrinter.printer_model_name.toLowerCase().contains("88 h")) {
                        zoneRichPrinter.connectPrinter(prepPrinter.ip);
                        CommonFunctions.functionThatDelay(200);
                        zoneRichPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, true, false);
                        if (buzzerSetting != null && !Validators.isNullOrEmpty(buzzerSetting.value) && buzzerSetting.value.toLowerCase().equalsIgnoreCase("yes") && prepLocation.cash_draw) {
                            zoneRichPrinter.connectPrinter(prepPrinter.ip);
                            CommonFunctions.functionThatDelay(200);
                            zoneRichPrinter.openCashDrawer();
                        }
                    } else if (prepPrinter.printer_model_name.toLowerCase().contains("t2") || prepPrinter.printer_model_name.toLowerCase().contains("sunmi")) {
                        sunmiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, true, false);
                        if (buzzerSetting != null && !Validators.isNullOrEmpty(buzzerSetting.value) && buzzerSetting.value.toLowerCase().equalsIgnoreCase("yes") && prepLocation.cash_draw) {
                            sunmiPrinter.openCashDrawer();
                        }
                    } else if (prepPrinter.printer_model_name.toLowerCase().contains("pos-80") || prepPrinter.printer_model_name.toLowerCase().contains("pos 80") || prepPrinter.printer_model_name.toLowerCase().contains("yoke4")) {
                        wifiPrinter.disconnect();
                        CommonFunctions.functionThatDelay(200);
                        wifiPrinter.connect(prepPrinter.ip);
                        CommonFunctions.functionThatDelay(200);
                        if (buzzerSetting != null && !Validators.isNullOrEmpty(buzzerSetting.value) && buzzerSetting.value.toLowerCase().equalsIgnoreCase("yes") && prepLocation.cash_draw) {
                            wifiPrinter.openCashDrawer(false);
                        }
                        wifiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, true, false);
                    }
                }
            }
            if (position >= prepOrderItems.size()) {
                try {
                    nextMethod.call();
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            myApp.isCashDrawerOpen = false;
        }
    }

    class OrderItemsPrintBlockAsync extends AsyncTask<Integer, Integer, Integer> {
        String title;
        ArrayList<OrderItem> groupedOrderItems = new ArrayList<>();
        Callable<Void> nextMethod;

        public OrderItemsPrintBlockAsync(String title, Callable<Void> nextMethod) {
            this.title = title;
            this.nextMethod = nextMethod;
        }

        @Override
        protected Integer doInBackground(Integer... integers) {
            List<OrderItem> miscOrderItems;
            List<OrderItem> productOrderItems;
            int _split_id = 0;
            if (integers.length > 0) {
                _split_id = integers[0];
                miscOrderItems = appDatabase.orderItemDao().orderItemsMiscForPrint(order._id, _split_id);
                productOrderItems = appDatabase.orderItemDao().orderItemProductForPrint(order._id, _split_id);
            } else {
                miscOrderItems = appDatabase.orderItemDao().orderItemsMiscForPrint(order._id);
                productOrderItems = appDatabase.orderItemDao().orderItemProductForPrint(order._id);
            }
            if (miscOrderItems != null && miscOrderItems.size() > 0) {
                groupedOrderItems.addAll(miscOrderItems);
            }

            if (productOrderItems != null && productOrderItems.size() > 0) {
                groupedOrderItems.addAll(productOrderItems);
            }
            if (_split_id > 0) {
                OrderSplit orderSplit = appDatabase.orderSplitDao().view(_split_id);
                order.total = orderSplit.total;
            }

            return 0;
        }

        @Override
        protected void onPostExecute(Integer integer) {
            super.onPostExecute(integer);
            Order tempOrder = new Gson().fromJson(new Gson().toJson(order), Order.class);

            tempOrder.order_items = groupedOrderItems;
            if (defaultPrinter.printer_model_name.toLowerCase().contains("88 h")) {
                zoneRichPrinter.connectPrinter(defaultPrinter.ip);
                CommonFunctions.functionThatDelay(200);
                zoneRichPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, true, footerA, footerB, false, false);
            } else if (defaultPrinter.printer_model_name.toLowerCase().contains("t2") || defaultPrinter.printer_model_name.toLowerCase().contains("sunmi")) {
                sunmiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, true, footerA, footerB, false, false);
            } else if (defaultPrinter.printer_model_name.toLowerCase().contains("pos-80") || defaultPrinter.printer_model_name.toLowerCase().contains("pos 80") || defaultPrinter.printer_model_name.toLowerCase().contains("yoke4")) {
                wifiPrinter.disconnect();
                CommonFunctions.functionThatDelay(100);
                wifiPrinter.connect(defaultPrinter.ip);
                CommonFunctions.functionThatDelay(100);
                wifiPrinter.printOrderEpos(myApp.businessLogo, title, (ticketHeaderSetting != null) ? ticketHeaderSetting.value : null, headerAlignment, tableOrOrderIdSetting != null ? tableOrOrderIdSetting.value : null, dateTimeModeInPrint, tempOrder, printTotalInPrint, footerA, footerB, false, false);

            }
            myApp.isCashDrawerOpen = false;
            try {
                nextMethod.call();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private void updateViews() {
        if (order != null && order.customer != null) {

            tvDeliveryTime.setVisibility(View.GONE);
            if (!Validators.isNullOrEmpty(order.order_type)) {
                if (order.order_status_id.equalsIgnoreCase("10")) {
                    tvOrderPaymentStatus.setText("Order Rejected");
                    btnCancelOrder.setVisibility(View.GONE);
                } else {
                    if (order.order_type.equalsIgnoreCase("Delivery")) {
                        tvOrderPaymentStatus.setText("Delivered");
                    } else if (order.order_type.equalsIgnoreCase("Collection")) {
                        tvOrderPaymentStatus.setText("Collected");
                    } else if (order.order_type.equalsIgnoreCase("Dine in")) {
                        tvOrderPaymentStatus.setText("Served");
                    } else {
                        tvOrderPaymentStatus.setText("Completed");
                    }
                }
            }
            tvOrderNumber.setText("Order #" + (order.id != null ? order.id : order._id));
            tvOrderPaymentStatus.setText(order.order_status);
            if (!Validators.isNullOrEmpty(order.customer.distance)) {
                tvMiles.setText(order.customer.distance + " Miles Away");
            } else {
                tvMiles.setVisibility(View.INVISIBLE);
            }
            if (!Validators.isNullOrEmpty(order.customer_name)) {
                tvCustomerName.setText("Name: " + order.customer_name);
            } else {
                tvCustomerName.setVisibility(View.GONE);
            }

            if (!Validators.isNullOrEmpty(order.customer.mobile)) {
                tvPhoneNo.setText("Mobile: " + order.customer.mobile);
            } else {
                tvPhoneNo.setVisibility(View.GONE);
            }

            if (!Validators.isNullOrEmpty(order.customer.house_no) && !Validators.isNullOrEmpty(order.customer.street) && !Validators.isNullOrEmpty(order.customer.city)) {
                tvAddress.setText("Delivery Address: " + order.customer.house_no + "," + order.customer.street + "," + order.customer.city);
            } else {
                tvAddress.setVisibility(View.GONE);
            }

            if (!Validators.isNullOrEmpty(order.comment)) {
                tvInstructions.setText(order.comment);
            } else {
                tvInstructionTitle.setVisibility(View.GONE);
                cvInstructions.setVisibility(View.GONE);
            }

            tvSubTotal.setText(String.format("%s%s", MyApp.currencySymbol, MyApp.df.format(order.sub_total)));


            if (order.service_charge > 0) {
                llServiceCharge.setVisibility(View.VISIBLE);
                tvServiceCharge.setText(String.format("%s%s", MyApp.currencySymbol, MyApp.df.format(order.service_charge)));
            } else {
                llServiceCharge.setVisibility(View.GONE);
            }

            if (order.delivery_charge > 0) {
                llDeliveryFee.setVisibility(View.VISIBLE);
                tvDeliveryFee.setText(String.format("%s%s", MyApp.currencySymbol, MyApp.df.format(order.delivery_charge)));
            } else {
                llDeliveryFee.setVisibility(View.GONE);
            }
            if (order.discount > 0) {
                llDiscount.setVisibility(View.VISIBLE);
                tvDiscount.setText(String.format("%s%s", MyApp.currencySymbol, MyApp.df.format(order.discount)));
            } else {
                llDiscount.setVisibility(View.GONE);
            }
            if (order.gratuity > 0) {
                llGratuity.setVisibility(View.VISIBLE);
                tvGratuityAmount.setText(String.format("%s%s", MyApp.currencySymbol, MyApp.df.format(order.gratuity)));
            } else {
                llGratuity.setVisibility(View.GONE);
            }

            StringBuilder personalDetails = new StringBuilder();

            if (!Validators.isNullOrEmpty(order.created_at)) {
                personalDetails = new StringBuilder();
                personalDetails.append("Ordered at: ");
                if (order.created_at.contains("Z")) {
                    personalDetails.append(CommonFunctions.formatUnknownDateTime(order.created_at, Constants.PHP_DATE_TIME_FORMAT_ZULU, "dd MMM, hh:mm a"));
                } else {
                    personalDetails.append(CommonFunctions.formatUnknownDateTime(order.created_at, Constants.PHP_DATE_TIME_FORMAT, "dd MMM, hh:mm a"));
                }
                tvOrderDate.setText(personalDetails.toString());
                tvOrderDate.setVisibility(View.VISIBLE);
            } else {
                tvOrderDate.setVisibility(View.GONE);
            }

            personalDetails = new StringBuilder();
            if (order_type > 0) {
                personalDetails.append("Required by: ");
                personalDetails.append(CommonFunctions.formatUnknownDateTime(order.delivery_date, Constants.PHP_DATE_TIME_FORMAT_ZULU, "hh:mm a"));
            } else {
                personalDetails = new StringBuilder();
                personalDetails.append("Served by: ");
                personalDetails.append("ASAP");
            }
            tvDeliveryTime.setText(personalDetails.toString());

            tvTotal.setText(String.format("%s%s", MyApp.currencySymbol, MyApp.df.format(order.total)));

        }
    }

    private void initViews(View view) {
        defaultPrinter = myApp.myPreferences.getDefaultPrinter();
        forceFullyDefaultPrinter = myApp.myPreferences.getDefaultPrinter(true);
        zoneRichPrinter = new ZoneRichPrinter(getActivity());
        wifiPrinter = WifiPrinter.getInstance();
        sunmiPrinter = new SunmiPrinter(getActivity());
        printers = selectedBusiness.printers;
        llMainLayout = view.findViewById(R.id.llMainLayout);
        ivClose = view.findViewById(R.id.ivClose);
        llLoading = view.findViewById(R.id.llLoading);
        llData = view.findViewById(R.id.llData);
        rvPayment = view.findViewById(R.id.rvPaymentMethods);
        btnPrint = view.findViewById(R.id.btnPrint);
        btnClose = view.findViewById(R.id.btnClose);
        btnCancelOrder = view.findViewById(R.id.btnCancelOrder);
        tvCustomerName = view.findViewById(R.id.tvCustomerName);
        tvPhoneNo = view.findViewById(R.id.tvCustomerMobile);
        tvAddress = view.findViewById(R.id.tvDeliveryAddress);
        tvInstructions = view.findViewById(R.id.tvInstructions);

        rvCartItems = view.findViewById(R.id.rvCartItems);
        tvOrderNumber = view.findViewById(R.id.tvOrderNumber);
        tvOrderPaymentStatus = view.findViewById(R.id.tvOrderPaymentStatus);
        tvOrderDate = view.findViewById(R.id.tvOrderDate);
        tvDeliveryTime = view.findViewById(R.id.tvDeliveryTime);
        tvMiles = view.findViewById(R.id.tvMiles);
        tvTotal = view.findViewById(R.id.tvTotal);

        tvSubTotal = view.findViewById(R.id.tvSubtotal);
        tvServiceCharge = view.findViewById(R.id.tvServiceFee);
        tvDeliveryFee = view.findViewById(R.id.tvDeliveryFee);
        tvDiscount = view.findViewById(R.id.tvDiscount);
        tvGratuityAmount = view.findViewById(R.id.tvGratuityAmount);
        tvInstructionTitle = view.findViewById(R.id.tvInstructionsTitle);
        cvInstructions = view.findViewById(R.id.cvInstruction);


        llDeliveryFee = view.findViewById(R.id.ll_Delivery);
        llDiscount = view.findViewById(R.id.ll_Discount);
        llServiceCharge = view.findViewById(R.id.ll_ServiceCharge);
        llGratuity = view.findViewById(R.id.ll_Gratuity);

        buzzerSetting = myApp.findSetting("open_cash_drawer_after_send_to_kitchen");
        ticketHeaderTypeSetting = myApp.findSetting("ticket_header_type");
        if (ticketHeaderTypeSetting != null && ticketHeaderTypeSetting.value.equalsIgnoreCase("right")) {
            headerAlignment = 2;
        }
        if (ticketHeaderTypeSetting != null && ticketHeaderTypeSetting.value.equalsIgnoreCase("center")) {
            headerAlignment = 1;
        }
        ticketHeaderSetting = myApp.findSetting("ticket_header");
        tableOrOrderIdSetting = myApp.findSetting("use_table_number_or_order_number");
        orderDateTimeSetting = myApp.findSetting("date_time_in_receipt_printing");

        if (orderDateTimeSetting != null) {
            dateTimeModeInPrint = orderDateTimeSetting.value;
        }
        footerASetting = myApp.findSetting("footer_a");
        footerBSetting = myApp.findSetting("footer_b");

        if (footerASetting != null) {
            footerA = footerASetting.value;
        }
        if (footerBSetting != null) {
            footerB = footerBSetting.value;
        }
        totalVisibilitySetting = myApp.findSetting("kitchen_total_visible");
        if (totalVisibilitySetting != null && (totalVisibilitySetting.value.equalsIgnoreCase("no") || totalVisibilitySetting.value.equalsIgnoreCase("false") || totalVisibilitySetting.value.equalsIgnoreCase("0"))) {
            printTotalInPrint = false;
        }
        serviceChargeEnableSetting = myApp.findSetting("is_service_charge");
        serviceChargeSetting = myApp.findSetting("service_charge");
        serviceChargeOptionSetting = myApp.findSetting("service_charge_type_option");
        serviceChargeTypeSetting = myApp.findSetting("service_charge_type");

        if (serviceChargeEnableSetting != null && (serviceChargeEnableSetting.value.equalsIgnoreCase("true") || serviceChargeEnableSetting.value.equalsIgnoreCase("1"))) {
            serviceChargeEnabled = true;
        }
        if (serviceChargeEnabled && serviceChargeOptionSetting != null && serviceChargeOptionSetting.value.equalsIgnoreCase("manual")) {
            serviceChargeAutoMode = false;
        }

        if (MyApp.userPermission != null && MyApp.userPermission.cancel_order.actions.list) {
            if (MyApp.userPermission.cancel_order_after_payment.actions.list)
                btnCancelOrder.setVisibility(View.VISIBLE);
            else
                btnCancelOrder.setVisibility(View.GONE);
        } else {
            btnCancelOrder.setVisibility(View.GONE);
        }

        rvCartItems.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));
        productItemsAdapter = new EposOrderedProductItemsAdapter(objects, true, new RecyclerviewItemClickListenerWithTag() {
            @Override
            public void onItemClick(int position, String tag, Object data) {
                OrderSplit split = (OrderSplit) data;
                if (split.selected) {
                    selectedSplit = split;
                } else {
                    selectedSplit = null;
                }
                new FetchOrderOfflineAsyncTask(() -> {
                    productItemsAdapter.notifyDataSetChanged();
                    return null;
                }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
            }
        });
        rvCartItems.setNestedScrollingEnabled(false);
        rvCartItems.setAdapter(productItemsAdapter);


        paymentsAdapter = new OrderPaymentsAdapter(orderPayments, true);
        rvPayment.setLayoutManager(new LinearLayoutManager(getActivity(), RecyclerView.VERTICAL, false));
        rvPayment.setNestedScrollingEnabled(false);
        rvPayment.setAdapter(paymentsAdapter);
    }

    private void fetchOffline() {
        new FetchOrderOfflineAsyncTask(() -> {
            updateViews();
            productItemsAdapter.notifyDataSetChanged();
            paymentsAdapter.notifyDataSetChanged();
            return null;
        }).executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR);
    }

    private class FetchOrderOfflineAsyncTask extends AsyncTask<Object, Object, Object> {
        Callable<Void> nextMethod;

        public FetchOrderOfflineAsyncTask(Callable<Void> nextMethod) {
            this.nextMethod = nextMethod;
        }

        @Override
        protected Object doInBackground(Object... object) {
            if (getActivity() != null) {
                getActivity().runOnUiThread(() -> {
                    llLoading.setVisibility(View.VISIBLE);
                    llData.setVisibility(View.INVISIBLE);
                });
            }

            orderWithItems = myApp.appDatabase.orderDao().orderWithItems(_order_id);
            if (orderWithItems != null) {
                order = orderWithItems.order;
                order.total_paid = myApp.appDatabase.orderPaymentDao().getTotalPaidAmount(_order_id);
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("1")) {
                    order.order_type = "Dine in";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("2")) {
                    order.order_type = "Collection";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("3")) {
                    order.order_type = "Delivery";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("4")) {
                    order.order_type = "Bar";
                }
                if (order.order_type_id != null && order.order_type_id.equalsIgnoreCase("5")) {
                    order.order_type = "Waiting";
                }

                if (!Validators.isNullOrEmpty(order.table_id))
                    order.table_number = appDatabase.tableDao().view(order.table_id).number;
                order.order_payments = (ArrayList<OrderPayment>) orderWithItems.orderPayments;
                orderPayments.clear();
                orderPayments.addAll(order.order_payments);

                order.order_splits = (ArrayList<OrderSplit>) orderWithItems.orderSplits;

                order.order_items = new ArrayList<>();
                orderItems.clear();
                HashMap<OrderSplit, List<OrderItem>> orderItemsWithSplitId = new HashMap<>();
                try {
                    for (OrderItemWithAddonsIngredients item : orderWithItems.orderItems) {
                        OrderItem orderItem = item.orderItem;
                        orderItem.order_item_addons = (ArrayList<OrderItemAddon>) item.orderItemAddons;
                        orderItem.order_item_ingredients = (ArrayList<OrderItemIngredient>) item.orderItemIngredients;
                        order.order_items.add(orderItem);
                        if (orderItem._order_split_id == 0) {
                            orderItems.add(orderItem);
                        } else {
                            OrderSplit split = new OrderSplit();
                            split._id = orderItem._order_split_id;
                            List<OrderItem> splitOrderItems = new ArrayList<>();
                            if (selectedSplit != null && split._id == selectedSplit._id) {
                                if (orderItemsWithSplitId.containsKey(split)) {
                                    splitOrderItems = orderItemsWithSplitId.get(split);
                                }
                                splitOrderItems.add(orderItem);
                            }
                            orderItemsWithSplitId.put(split, splitOrderItems);
                        }
                    }
                    Collections.reverse(orderItems);
                    if (!Validators.isNullOrEmpty(order.split_type) && order.split_type.equalsIgnoreCase("order_item")) {
                        //We will show none splitted items first.
                        objects.clear();
                        objects.addAll(orderItems);

                        for (Map.Entry<OrderSplit, List<OrderItem>> entry : orderItemsWithSplitId.entrySet()) {

                            OrderSplit split = appDatabase.orderSplitDao().view(entry.getKey()._id);
                            if (selectedSplit != null && split._id == selectedSplit._id) {
                                split.selected = true;
                            }
                            LogUtils.e("ONREFRESH : SPLIT: " + new Gson().toJson(split));
                            objects.add(split);
                            objects.addAll(entry.getValue());
                        }
                    } else {
                        objects.clear();
                        objects.addAll(orderItems);
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
                cartDiscount = order.discount;
                cartServiceCharge = order.service_charge;
                order.customer = myApp.appDatabase.customerDao().view(order._customer_id);
                if (order.customer == null) {
                    order.customer = myApp.appDatabase.customerDao().view(order.customer_id);
                }

                order.total = order.sub_total + order.gratuity - order.discount + order.service_charge + order.delivery_charge;
                ;
                myApp.setOrderItems(orderItems);
            }
            return null;
        }

        @Override
        protected void onPostExecute(Object s) {
            super.onPostExecute(s);
            if (order != null) {
                if (nextMethod != null) {
                    try {
                        nextMethod.call();
                        if (getActivity() != null) {
                            getActivity().runOnUiThread(() -> {
                                llLoading.setVisibility(View.GONE);
                                llData.setVisibility(View.VISIBLE);
                            });
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            } else {
                if (getActivity() != null) {
                    getActivity().runOnUiThread(() -> {
                        llLoading.setVisibility(View.INVISIBLE);
                        llData.setVisibility(View.INVISIBLE);
                    });
                }
            }
        }
    }

}
