package com.example.epos_2021.fragment;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.DialogFragment;

import com.example.epos_2021.MyApp;
import com.example.epos_2021.R;
import com.example.epos_2021.interfaces.DialogDismissListener;
import com.example.epos_2021.models.SiteSetting;
import com.google.android.material.button.MaterialButton;
import com.google.android.material.chip.Chip;
import com.google.gson.Gson;

/**
 * Created by Sumeet on 23-12-2021.
 */
public class PrintOptionsDialogAutoDineInFragment extends DialogFragment {
    @Override
    public int getTheme() {
        return R.style.MyDialog;
    }

    @Override
    public void onStart() {
        super.onStart();
        getDialog().setCancelable(false);
        getDialog().getWindow().setLayout(ViewGroup.LayoutParams.WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
    }

    private MaterialButton btnPrintAll,btnCancel;
    private DialogDismissListener dialogDismissListener;
    private Chip chipBack;

    public void setDialogDismissListener(DialogDismissListener dialogDismissListener) {
        this.dialogDismissListener = dialogDismissListener;
    }

    public static PrintOptionsDialogAutoDineInFragment getInstance() {
        return new PrintOptionsDialogAutoDineInFragment();
    }

    public static PrintOptionsDialogAutoDineInFragment getInstance( SiteSetting printAllMainSetting) {
        PrintOptionsDialogAutoDineInFragment fragment = new PrintOptionsDialogAutoDineInFragment();
        Bundle bundle = new Bundle();
        bundle.putString("printAllSetting", new Gson().toJson(printAllMainSetting));
        fragment.setArguments(bundle);
        return fragment;
    }

    private SiteSetting printAllMainSetting;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        return inflater.inflate(R.layout.dialog_print_options_dinein_auto_fragment, container, false);
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        if (getArguments() != null) {
            printAllMainSetting = new Gson().fromJson(getArguments().getString("printAllSetting"), SiteSetting.class);
        }
        initViews(view);
        setListeners();
    }

    private void initViews(View view) {
        btnPrintAll = view.findViewById(R.id.btnPrintAll);
        btnCancel = view.findViewById(R.id.btnCancel);
        chipBack = view.findViewById(R.id.chipBack);

        if (MyApp.userPermission.print_all.actions.list && printAllMainSetting != null && (printAllMainSetting.value.equalsIgnoreCase("true") || printAllMainSetting.value.equalsIgnoreCase("1"))) {
            btnPrintAll.setVisibility(View.VISIBLE);
        } else {
            btnPrintAll.setVisibility(View.GONE);
        }
    }

    private void setListeners() {
        btnPrintAll.setOnClickListener(view -> {
            if (dialogDismissListener != null) {
                dialogDismissListener.onDialogDismiss("print_all");
                dismiss();
            }
        });
        btnCancel.setOnClickListener(view -> {
            dismiss();
        });
        chipBack.setOnClickListener(view -> {
            dismiss();
        });
    }

}
