package com.example.epos_2021.models;

import androidx.room.Entity;
import androidx.room.Ignore;
import androidx.room.PrimaryKey;

import java.util.ArrayList;
import java.util.Objects;

/**
 * Created by Amrish on 04-05-2021.
 */
@Entity
public class Order {
    @PrimaryKey(autoGenerate = true)
    public int _id;
    public int _customer_id;

    public String id;
    public String comment;
    public String created_at;
    public String updated_at;
    public String customer_id;
    public String customer_name;
    public String delivery_date;
    public String device_id;
    public String split_type; //order_item,person
    public int split_count;
    public String order_action_id;
    public String order_status;
    public String order_status_id;
    public String order_type;
    public String order_type_id;
    public String preparation_location_id;
    public String table_id;
    public String table_number;
    public float sub_total;
    public float gratuity;
    public float service_charge;
    public float delivery_charge;
    public float discount;
    public float tax;
    public float total;
    public float total_paid;
    public String updater_id;
    public String no_guest;
    public boolean is_archived;
    public int print_id;
    @Ignore
    public boolean selected, expanded;
    @Ignore
    public Customer customer;
    @Ignore
    public ArrayList<Product> product_items;
    @Ignore
    public ArrayList<OrderItem> order_items;
    @Ignore
    public ArrayList<OrderSplit> order_splits;
    @Ignore
    public ArrayList<OrderPayment> order_payments;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Order order = (Order) o;
        return _id == order._id;
    }

    @Override
    public int hashCode() {
        return Objects.hash(_id);
    }
}
